-- UberFlex AutoCombat System.
-- Created by Ahmed Mohamed el-Sawalhy. Forums member: os008. 3nj0yz!


-- The MIT License 

-- Copyright (c) 2009 Ahmed el-Sawalhy

-- Permission is hereby granted, free of charge, to any person obtaining a copy
-- of this software and associated documentation files (the "Software"), to deal
-- in the Software without restriction, including without limitation the rights
-- to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is
-- furnished to do so, subject to the following conditions: 

-- The above copyright notice and this permission notice shall be included in
-- all copies or substantial portions of the Software. 

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
-- IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-- FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
-- AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-- LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
-- OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
-- THE SOFTWARE. 


-- Credits:
-- Valacar <Simple timer example using OnUpdate>. Thanks :).
-- Valacar <WarningOverride>.
-- gfaskyranger <Checked some methods he used in his mod HealBot>.
-- Zilvermoon <Helped me with advice making the UI>.
-- TheGooch <Pointed out an error in the saving script>.
-- Krankhaft/Qwox/novayuna <Their addons helped me understand how some stuff works, addons HudBars2/qUnitFrames/pbInfo>.
-- Anonymous <GetActionUsable()>. Thanks :).
-- peacemaster <Punish script for checking on Light Seals>.
-- Noktrin <Gave me the idea to not cast while mounted>.
-- adisadicul <Checked how he implemented the slidebar in his mod yBag>.
-- Zilvermoon, and sveed <Gave me hints on how to format textures for RoM>.
-- Noktrin <Gave me the idea to make a help screen after i looked at his mod nBuff, and the slots picture is his :)>.
-- lynxxger <Re-worked the 'debuff' checking function for me>.

------------------------------------------------------
-- Timer 1 : Used for all skills/buff/potion in combat
------------------------------------------------------
function SimpleTimer_OnLoad(this)

	this:RegisterEvent("CASTING_START");
	this:RegisterEvent("CASTING_STOP");
	this:RegisterEvent("CASTING_FAILED");
	this:RegisterEvent("CASTING_DELAYED");
	
	this:RegisterEvent("SKILL_UPDATE");
	this:RegisterEvent("SKILL_UPDATE_COOLDOWN");

	this:RegisterEvent("COMBATMETER_DAMAGE");
	this:RegisterEvent("COMBATMETER_HEAL");
	
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_BUFF_CHANGED");
	this:RegisterEvent("UNIT_CLASS_CHANGED");
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("UNIT_TARGET_CHANGED");
	this:RegisterEvent("UNIT_SKILL");
	
	this:RegisterEvent("PLAYER_BUFF_CHANGED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("PLAYER_SKILLED_CHANGED");
	this:RegisterEvent("PLAYER_INVENTORY_CHANGED");
	this:RegisterEvent("PLAYER_EXP_CHANGED");
	
	this:RegisterEvent("PLAYER_EQUIPMENT_UPDATE");
	this:RegisterEvent("PLAYER_BAG_CHANGED");
	this:RegisterEvent("PLAYER_ABILITY_CHANGED");
	
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");	
	
	this:RegisterEvent("PLAYER_ALIVE");

	this.delayTime = 0.4;                   -- seconds to wait
	this.remainingTime = this.delayTime;  -- initialize to delay time

	acsStatus=true;

	acsRegistered=false;
	
	this.acsCombatTempSwitchTarget=false;
	
	this.timer1Lock = false;
	
	Load_ACS_Vars();
	
	if ( GetLanguage()=="ENEU" or GetLanguage()=="ENUS" ) then
		acsRide1="horse";
		acsRide2="warhorse";
		acsRide3="ostrich";
		acsRide4="berhu"
		acsRide5="unicorn"
		acsRide6="wartiger"
		acsRide7="ice beast"
		acsRide8="boar"
		acsRide9="ferret"
		acsRide10="lion riding"
		acsRide11="rhinoceros"
		acsRide12="fungus"
		acsRide13="acsRide13"	-- 13~16 reserved for new mounts
		acsRide14="acsRide14"
		acsRide15="acsRide15"
		acsRide16="acsRide16"
		acsMage="Mage";
		acsKnight="Knight";
		acsPriest="Priest";
		acsWarden="Warden";
		acsDruid="Druid";
		acsStun="stun"
		acsShock="shock"
		acsVanish="vanish"
		acsHide="hide"
		acsSafe="safe"
	else
		acsRide1="schwarzes streitross";
		acsRide2="einhorn";
		acsRide3="strau\195\159";
		acsRide4="kriegstiger"
		acsRide5="berhu "
		acsRide6="frettchen"
		acsRide7="eisbestie"
		acsRide8="keiler"
		acsRide9="schneebestie"
		acsRide10="l\195\182we"
		acsRide11="rhinozeros"
		acsRide12="schimmel"
		acsRide13="wei\195\159es Streitross"
		acsRide14="schecke"
		acsRide15="braunes pferd"
		acsRide16="rappe"
		acsMage="Magier";
		acsKnight="Ritter";
		acsPriest="Priester";
		acsWarden="Bewahrer";
		acsDruid="Druide";
		acsStun="aufladungseffekt"
		acsShock="shock"
		acsVanish="vanish"
		acsHide="verbergen"
		acsSafe="wohlbehalten"
	end
	
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000TimeTicker|r for UFAutoCS: ready to tick.", 0.8, 0.8, 1.0)

	SimpleTimer:Hide();
	
end
------------------------------------------------
-- Timer 2 : Used for self-buff
------------------------------------------------
function SimpleTimer_OnLoad2(this)

	this:RegisterEvent("CASTING_START");
	this:RegisterEvent("CASTING_STOP");
	this:RegisterEvent("CASTING_FAILED");
	this:RegisterEvent("CASTING_DELAYED");
	
	this:RegisterEvent("SKILL_UPDATE");
	this:RegisterEvent("SKILL_UPDATE_COOLDOWN");

	this:RegisterEvent("COMBATMETER_DAMAGE");
	this:RegisterEvent("COMBATMETER_HEAL");
	
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_BUFF_CHANGED");
	this:RegisterEvent("UNIT_CLASS_CHANGED");
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("UNIT_TARGET_CHANGED");
	this:RegisterEvent("UNIT_SKILL");
	
	this:RegisterEvent("PLAYER_BUFF_CHANGED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("PLAYER_SKILLED_CHANGED");
	this:RegisterEvent("PLAYER_INVENTORY_CHANGED");
	this:RegisterEvent("PLAYER_EXP_CHANGED");
	this:RegisterEvent("PLAYER_EQUIPMENT_UPDATE");
	this:RegisterEvent("PLAYER_BAG_CHANGED");
	this:RegisterEvent("PLAYER_ABILITY_CHANGED");
	
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
	
	this:RegisterEvent("PLAYER_ALIVE");

	this.delayTime2 = 0.8;                   -- seconds to wait
	this.remainingTime2 = this.delayTime2;  -- initialize to delay time
	this.timer2Lock = false;

	Load_ACS_Vars2();
	
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000BuffTicker|r for UFAutoCS: ticking.", 0.8, 0.8, 1.0)
	
end

------------------------------------------------
-- Timer 3 : Used for animated icon
------------------------------------------------
function SimpleTimer3_OnLoad(this)

	this:RegisterEvent("LOADING_END");
	
	this.delayTime3 = 0.04;                   -- seconds to wait
	this.remainingTime3 = this.delayTime3;  -- initialize to delay time
	
	if ( acsIcon==nil ) then
		acsIcon=true;
	end

	acsPicSeq=1000;
	acsCombatStarted=false;

	delayedTimer3=false;
	delayThisMuch3=10;

	acsLastSeqUsed="star";

	SaveVariables("acsIconX");
	SaveVariables("acsIconY");

end


function SimpleTimer_OnEvent(this, event)

	if ( event == "CASTING_START") then
		castStatus="started";
		useMeleeAttack=false;
	end
	
	if ( event == "CASTING_STOP") then
		castStatus="finished";
		useMeleeAttack=true;
	end

	if ( event == "CASTING_FAILED") then
		castStatus="failed";
		useMeleeAttack=true;
	end
	
	if ( event == "CASTING_DELAYED") then
		castStatus="delayed";
		useMeleeAttack=true;
	end
	
	if( not this.timer1Lock ) then
		this.timer1Lock=true;
		SimpleTimer1_EventHandler();
	end
	
	-- Debug event message, just wants to see what's happened 
	--DEFAULT_CHAT_FRAME:AddMessage("event: "..event);

end


function SimpleTimer_OnEvent2(this, event)

	if ( event == "CASTING_START") then
		castStatus2="started";
	end
	
	if ( event == "CASTING_STOP") then
		castStatus2="finished";
	end

	if ( event == "CASTING_FAILED") then
		castStatus2="failed";
	end
	
	if ( event == "CASTING_DELAYED") then
		castStatus2="delayed";
	end
	
	if( not this.timer2Lock ) then
		this.timer2Lock=true;
		SimpleTimer2_EventHandler();
	end
end


function SimpleTimer3_OnEvent(this, event)

	if ( event == "LOADING_END" ) then
		if ( ( not acsIconX ) or ( not acsIconY ) ) then
			SimpleTimer3:ClearAllAnchors();
			SimpleTimer3:SetAnchor("TOPLEFT", "TOPLEFT", "UIParent", 170, 120);	
		else
			SimpleTimer3:ClearAllAnchors();
			local scale = GetUIScale();
			SimpleTimer3:SetAnchor("TOPLEFT", "TOPLEFT", "UIParent", acsIconX/scale, acsIconY/scale); 	
		end;
		
		SimpleTimerIcon:SetTexture("Interface/AddOns/UberFlex AutoCombat System/Pix/creepy.tga");
	end
	
end


function Load_ACS_Vars()

	useMeleeAttack=true;
	
	acsTempCastGo1=true;
	acsTempCastGo2=true;
	
	acsTempHPGo=true;
	acsTempMPGo=true;
	
	acsEndCombatFlag=false;

	acsIndex=1;

	delayTimer=false;
	delayedTimer=false;
	delayThisMuch=0.034;
	
	acsJustCast=false;
	
	acsCurrentSpell=0;
	
	castStatus="finished";
	castStatus2="finished";

	acsResetPing=true;
	acsPingAverage=GetPing();
	acsIndexPinger=1;

end


function Load_ACS_Vars2()

	castStatus2="finished";

end


function SimpleTimer_OnUpdate(this, elapsedTime)
	this.remainingTime = this.remainingTime - elapsedTime;  -- count down
	if ( this.remainingTime < 0 ) then  -- check when we run out of time
		this.timer1Lock=false; 	-- unlock timer1
		this.remainingTime = this.delayTime;
	end
end

-- Combat Stuff
function SimpleTimer1_EventHandler()
	if ( acsCombatStarted == false ) then return end

	if ( acsEndCombatFlag ) then
		engageEnd();
		return;
	end
		
	local acsIsPlayer=UnitIsPlayer("target");
		
	if ( ( math.ceil(UnitHealth("target")) )>0 and UnitCanAttack("player", "target") and ( not acsIsPlayer ) and ( not acsBuffPlayerCheck(acsVanish) ) ) then
			acsCombatStart();
	elseif ( ( math.ceil(UnitHealth("target")) )>0 and UnitCanAttack("player", "target") and acsIsPlayer and ( not acsBuffPlayerCheck(acsVanish) )  ) then
			acsCombatPvPStart();
	else
		if ( ( ( math.ceil(UnitHealth("target")) )<=0 or UnitCanAttack("player", "target") ) and ( not acsBuffPlayerCheck(acsVanish) ) ) then
			--acsBuffStuck();
			if ( acsPreCastChecks() ) then
				acsBuffStart();
			end
		end
			
		local healOthersStatus=false;
		local buffOthersStatus=false;
			
		for i=1,20 do
			if ( acsPvEHealOthers[i] ) then
				healOthersStatus=true;
				break;
			end
		end
			
		if ( healOthersStatus and ( math.ceil(UnitHealth("target")) )>0 and ( not UnitCanAttack("player", "target") ) and acsIsPlayer and ( not acsBuffPlayerCheck(acsVanish) ) ) then
			acsHealStart()
		end
			
		for i=1,20 do
			if ( acsPvEBuffOthers[i] ) then
				buffOthersStatus=true;
				break;
			end
		end

		if ( buffOthersStatus and ( math.ceil(UnitHealth("target")) )>0 and ( not UnitCanAttack("player", "target") ) and acsIsPlayer and ( not acsBuffPlayerCheck(acsVanish) ) ) then
			
			if ( acsPreCastChecks() ) then
				--DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Buff Others!|r");
				acsBuffOthersStart();
			end
		end
			
		--DEFAULT_CHAT_FRAME:AddMessage("acsCombatTempSwitchTarget:"..tostring(SimpleTimer.acsCombatTempSwitchTarget));
		if ( ( ( ( not healOthersStatus ) and ( not buffOthersStatus ) ) or ( math.ceil(UnitHealth("target")) )<=0 ) and ( not acsManualSwitch ) and ( not SimpleTimer.acsCombatTempSwitchTarget) ) then
			if ( not acsLoot ) then
				engageEnd();
			else
				acsEndCombatFlag=true;
			end
		end
	end

	if ( UnitName("target")==UnitName("player") and ( not SimpleTimer.acsCombatTempSwitchTarget) ) then
		TargetUnit();
	end	
end

function SimpleTimer_OnUpdate2(this, elapsedTime)


	if ( ( not acsRegistered ) and AddonManager ) then
	
		local addon = {
			name = "UberFlex AutoCombat System",
			version = "v13.06.7032",
			author = "Ahmed el-Sawalhy (os008)",
			description = "Limited auto-combat system, don't have to press anything during battle, and YOU setup your own script. Includes: Debuff checks, spell cycling, out and in-combat buffs casting, pots, heals/protects.",
			icon = "Interface/AddOns/UberFlex AutoCombat System/Pix/creepy.tga",
			category = "Leveling",
			configFrame = acsConfPanelFrame2, 
			slashCommand = "/engage",
			miniButton = UFACSMiniButton,
		};
		
		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon);
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author);
		end
		
		acsRegistered=true;
		
	end
	
	

	--[[
	if ( ( ( not ACS_Vars_Loaded ) and ( not acsConfVariablesLoaded ) and UnitName("player") and UnitClass("player") ) or ( acsClass~=UnitClass("player") and UnitName("player") and UnitClass("player") ) ) then
		acsConfRunnerFrame_VARIABLES_LOAD();
	else
		if ( ( not ACS_Vars_Loaded ) and ( not acsConfVariablesLoaded ) ) then
			return;
		end
	end
	--]]

	this.remainingTime2 = this.remainingTime2 - elapsedTime;  -- count down
	--DEFAULT_CHAT_FRAME:AddMessage("|cff00FF00"..tostring(this.remainingTime2).."|r");
	
	if ( ( this.remainingTime2 < 0 ) ) then 
		this.timer2Lock=false; 	-- unlock timer2
		this.remainingTime2 = this.delayTime2;
	end

	--[[
	if ( ( this.remainingTime2 < 0 ) and ACS_Vars_Loaded and acsConfVariablesLoaded ) then  -- check when we run out of time

		local acsIsPlayer=UnitIsPlayer("target");

		if ( UnitName("target")==UnitName("player") ) then
			TargetUnit();
		end
		
		if ( UnitHealth("player")>0 and ( UnitCanAttack("player", "target") or ( UnitName("target")=="" or UnitName("target")==nil ) ) and ( not ( acsBuffPlayerCheck(acsRide1) or acsBuffPlayerCheck(acsRide2) or acsBuffPlayerCheck(acsRide3) or acsBuffPlayerCheck(acsRide4) or acsBuffPlayerCheck(acsRide5) or acsBuffPlayerCheck(acsRide6) or acsBuffPlayerCheck(acsRide7) or acsBuffPlayerCheck(acsRide8) or acsBuffPlayerCheck(acsRide9) or acsBuffPlayerCheck(acsRide10) or acsBuffPlayerCheck(acsSafe) or acsBuffPlayerCheck(acsVanish) or acsDebuffPlayerCheck(acsSafe) or acsBuffPlayerCheck(acsHide) ) ) ) then
			this.remainingTime2 = this.delayTime2;
			acsBuffStart();
		end

	end
	--]]
end

-- Buffer Stuff
function SimpleTimer2_EventHandler()
	if ( ( ( not ACS_Vars_Loaded ) and ( not acsConfVariablesLoaded ) and UnitName("player") and UnitClass("player") ) or ( acsClass~=UnitClass("player") and UnitName("player") and UnitClass("player") ) ) then
		acsConfRunnerFrame_VARIABLES_LOAD();
	else
		if ( ( not ACS_Vars_Loaded ) and ( not acsConfVariablesLoaded ) ) then
			return;
		end
	end

	if ( ACS_Vars_Loaded and acsConfVariablesLoaded ) then  -- check when we run out of time

		local acsIsPlayer=UnitIsPlayer("target");

		if ( UnitName("target")==UnitName("player") ) then
			TargetUnit();
		end
		
		-- if mounted or in the state of safe/vanish/hide, do not auto-buff
		if ( UnitHealth("player")>0 and ( UnitCanAttack("player", "target") or ( UnitName("target")=="" or UnitName("target")==nil ) ) and ( not ( acsBuffPlayerCheck(acsRide1) or acsBuffPlayerCheck(acsRide2) or acsBuffPlayerCheck(acsRide3) or acsBuffPlayerCheck(acsRide4) or acsBuffPlayerCheck(acsRide5) or acsBuffPlayerCheck(acsRide6) or acsBuffPlayerCheck(acsRide7) or acsBuffPlayerCheck(acsRide8) or acsBuffPlayerCheck(acsRide9) or acsBuffPlayerCheck(acsRide10) or acsBuffPlayerCheck(acsRide11) or acsBuffPlayerCheck(acsRide12) or acsBuffPlayerCheck(acsRide13) or acsBuffPlayerCheck(acsRide14) or acsBuffPlayerCheck(acsRide15) or acsBuffPlayerCheck(acsRide16) or acsBuffPlayerCheck(acsSafe) or acsBuffPlayerCheck(acsVanish) or acsDebuffPlayerCheck(acsSafe) or acsBuffPlayerCheck(acsHide) ) ) ) then
			if ( acsPreCastChecks() ) then	-- Prevent from rebuff crazily 2009/10/11
				--DEFAULT_CHAT_FRAME:AddMessage("|cff00FF00Buff Self!|r");
				acsBuffStart();
			end
		end

	end
end


function SimpleTimer3_OnUpdate(this, elapsedTime)

	if ( acsIcon==false ) then
		this:Hide();
	end

	if ( delayedTimer3 and acsCombatStarted ) then
		this.remainingTime3 = this.delayTime3;
		delayedTimer3=false;
	end

	this.remainingTime3 = this.remainingTime3 - elapsedTime;  -- count down

	if ( this.remainingTime3 < 0 ) then  -- check when we run out of time
	
		if ( acsCombatStarted and acsSeqToUse=="jumpy" ) then
			if ( acsPicSeq>=614 ) then
				acsPicSeq=601;
			else
				acsPicSeq=acsPicSeq+1;
			end
			SimpleTimerIcon:SetTexture("Interface/AddOns/UberFlex AutoCombat System/Pix/jumpy"..( acsPicSeq-600 )..".tga");
			acsLastSeqUsed="jumpy";
			this.remainingTime3 = this.delayTime3;
			return;
		end

		if ( acsCombatStarted and acsSeqToUse=="crazycat" ) then
			if ( acsPicSeq>=512 ) then
				acsPicSeq=501;
			else
				acsPicSeq=acsPicSeq+1;
			end
			SimpleTimerIcon:SetTexture("Interface/AddOns/UberFlex AutoCombat System/Pix/crazycat"..( acsPicSeq-500 )..".tga");
			acsLastSeqUsed="crazycat";
			this.remainingTime3 = this.delayTime3;
			return;
		end

		if ( acsCombatStarted and acsSeqToUse=="crazy" ) then
			if ( acsPicSeq>=402 ) then
				acsPicSeq=401;
			else
				acsPicSeq=acsPicSeq+1;
			end
			SimpleTimerIcon:SetTexture("Interface/AddOns/UberFlex AutoCombat System/Pix/crazy"..( acsPicSeq-400 )..".tga");
			acsLastSeqUsed="crazy";
			this.remainingTime3 = this.delayTime3;
			return;
		end

		if ( acsCombatStarted and acsSeqToUse=="star" ) then
			if ( acsPicSeq>=326 ) then
				acsPicSeq=301;
			else
				acsPicSeq=acsPicSeq+1;
			end
			SimpleTimerIcon:SetTexture("Interface/AddOns/UberFlex AutoCombat System/Pix/star"..( acsPicSeq-300 )..".tga");
			acsLastSeqUsed="star";
			this.remainingTime3 = this.delayTime3;
			return;
		end

		if ( acsCombatStarted and acsSeqToUse=="cat" ) then
			if ( acsPicSeq>=104 ) then
				acsPicSeq=101;
			else
				acsPicSeq=acsPicSeq+1;
			end
			SimpleTimerIcon:SetTexture("Interface/AddOns/UberFlex AutoCombat System/Pix/cat"..( acsPicSeq-100 )..".tga");
			acsLastSeqUsed="cat";
			this.remainingTime3 = this.delayTime3;
			return;
		end
	
		if ( not acsCombatStarted ) then
			SimpleTimerIcon:SetTexture("Interface/AddOns/UberFlex AutoCombat System/Pix/creepy.tga");
			delayedTimer3=true;
			this.remainingTime3 = delayThisMuch3;
		end
		
	end
	
end
	

function acsSaveIconPosition()
	SimpleTimer3:StopMovingOrSizing();
	acsIconX, acsIconY = SimpleTimer3:GetPos();
end


function configACS()

	if ( acsConfPanelFrame2:IsVisible() ) then
		acsConfPanelFrame2:Hide();
	else
		acsConfPanelFrame2:Show();
	end
	
end


function engageStart()

	if ( ( not SimpleTimer:IsVisible() ) ) then
	
		Load_ACS_Vars()
		
		if ( ACS_Vars_Loaded and acsConfVariablesLoaded and acsStatus ) then
		
			SimpleTimer:Show();
			SimpleTimer2:Hide();
			DisableSendWarningMsg11();
			acsCombatStarted=true;
			-- When user call /acs or /engage or .... , we must start auto-combat right away, added the following code 2009/10/09
			SimpleTimer1_EventHandler();
			
			if ( acsLastSeqUsed=="star" ) then
				acsSeqToUse="cat";
			elseif ( acsLastSeqUsed=="cat" ) then
				acsSeqToUse="jumpy";
				acsPicSeq=1000;
			elseif ( acsLastSeqUsed=="jumpy" ) then
				acsSeqToUse="crazycat";
			elseif ( acsLastSeqUsed=="crazycat" ) then
				acsSeqToUse="crazy";
			elseif ( acsLastSeqUsed=="crazy" ) then
				acsSeqToUse="star";
			end
			
		else
			
			acsVariables();

			if ( ACS_Vars_Loaded and acsStatus ) then
				SimpleTimer:Show();
				acsCombatStarted=true;
				SimpleTimer2:Hide();

				if ( acsLastSeqUsed=="star" ) then
					acsSeqToUse="cat";
				elseif ( acsLastSeqUsed=="cat" ) then
					acsSeqToUse="jumpy";
					acsPicSeq=1000;
				elseif ( acsLastSeqUsed=="jumpy" ) then
					acsSeqToUse="crazycat";
				elseif ( acsLastSeqUsed=="crazycat" ) then
					acsSeqToUse="crazy";
				elseif ( acsLastSeqUsed=="crazy" ) then
					acsSeqToUse="star";
				end
			
			else
				if ( not acsStatus ) then
					DEFAULT_CHAT_FRAME:AddMessage("|cffff0000ERROR|r: UFACS is |cffff0000OFFLINE|r!");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cffff0000ERROR|r: Variables not loaded for UFACS!");
					acsCombatStarted=false;
					engageEnd();
				end
				
				return;
			end
		end

	else
		if ( acsSingleSwitch ) then
			engageEnd();
		end
	end

end


function engageStart1()

	acs[acsPlayerName][acsClass]["ProfileSelected"]=1;
	acsVariables();
	engageStart();
	
end


function engageStart2()

	acs[acsPlayerName][acsClass]["ProfileSelected"]=2;
	acsVariables();
	engageStart();
	
end


function engageEnd()

	SimpleTimer:Hide();

	if ( acsLoot ) then
		UseAction(acsPvEAttackSlot);
	end

	SimpleTimer2:Show();
	EnableSendWarningMsg11();
	acsCombatStarted=false;
	
	return;

end


function acsDebuffTargetCheck(whatdebuff)
	whatdebuff=string.lower(whatdebuff);
	local i = 1;
	local DebuffName, DebuffIcon, DebuffCount = UnitDebuff("target", i);
	while (DebuffName ~= nil) do
		if (string.find(string.lower(DebuffName),whatdebuff)~=nil ) then
			return DebuffCount;
		end
		i = i + 1;
		DebuffName, DebuffIcon, DebuffCount = UnitDebuff("target", i);
	end

	return;
end


function acsDebuffPlayerCheck(whatdebuff)
	whatdebuff=string.lower(whatdebuff);
	local i = 1;
	local DebuffName, DebuffIcon, DebuffCount = UnitDebuff("player", i);
	while (DebuffName ~= nil) do
		if (string.find(string.lower(DebuffName),whatdebuff)~=nil ) then
			return ( DebuffCount+1 );
		end
		i = i + 1;
		DebuffName, DebuffIcon, DebuffCount = UnitDebuff("player", i);
	end

	return;
end

function acsBuffPlayerCheck(whatbuff)
	whatbuff=string.lower(whatbuff);
	local i = 1;
	local BuffName, BuffIcon, BuffCount = UnitBuff("player", i);
	while (BuffName ~= nil) do
		if (string.find(string.lower(BuffName),whatbuff)~=nil ) then
			return ( BuffCount+1 );
		end
		i = i + 1;
		BuffName, BuffIcon, BuffCount = UnitBuff("player", i);
	end

	return;
end

function acsBuffTargetCheck(whatbuff)
	whatbuff=string.lower(whatbuff);
	local i = 1;
	local BuffName, BuffIcon, BuffCount = UnitBuff("target", i);
	while (BuffName ~= nil) do
		if (string.find(string.lower(BuffName),whatbuff)~=nil ) then
			return ( BuffCount+1 );
		end
		i = i + 1;
		BuffName, BuffIcon, BuffCount = UnitBuff("target", i);
	end

	return;
end

function acsToggle()

	if ( acsStatus ) then
		SimpleTimer:Hide();
		SimpleTimer3:Hide();
		SimpleTimer2:Hide();
		UFACSMiniButton:Hide();
		acsStatus=false;
		DEFAULT_CHAT_FRAME:AddMessage("UberFlex AutoCombat System: |cffff0000DE-ACTIVATED|r.", 0.5, 0.7, 0.1);
	else
		SimpleTimer:Hide();
		
		if ( acsIcon ) then
			SimpleTimer3:Show();
		end
		
		SimpleTimer2:Show();
		UFACSMiniButton:Show();
		acsStatus=true;
		DEFAULT_CHAT_FRAME:AddMessage("UberFlex AutoCombat System: |cffff0000ACTIVATED|r.", 0.5, 0.7, 0.1);
	end
	
end

SLASH_UFAUTOCSSTART1 = "/engage";
SLASH_UFAUTOCSSTART2 = "/acs";
SlashCmdList["UFAUTOCSSTART"] = engageStart;

SLASH_UFAUTOCSSTART11 = "/engage1";
SLASH_UFAUTOCSSTART12 = "/acs1";
SlashCmdList["UFAUTOCSSTART1"] = engageStart1;

SLASH_UFAUTOCSSTART21 = "/engage2";
SLASH_UFAUTOCSSTART22 = "/acs2";
SlashCmdList["UFAUTOCSSTART2"] = engageStart2;

SLASH_UFAUTOCSCONFIG1 = "/configacs";
SLASH_UFAUTOCSCONFIG2 = "/acsconfig";
SlashCmdList["UFAUTOCSCONFIG"] = configACS;

SLASH_UFAUTOCSTOGGLE1 = "/toggleacs";
SLASH_UFAUTOCSTOGGLE2 = "/acstoggle";
SlashCmdList["UFAUTOCSTOGGLE"] = acsToggle;

SLASH_UFAUTOCSEND1 = "/disengage";
SLASH_UFAUTOCSEND2 = "/acsend";
SlashCmdList["UFAUTOCSEND"] = engageEnd;

DEFAULT_CHAT_FRAME:AddMessage("|cffff0000UberFlex AutoCombat System|r: activated, |cffff0000v13.06.7032|r (made by os008), |cff00ffffv0.3|r (fan update)", 0.5, 0.7, 0.1);