-- UberFlex AutoCombat System.
-- Created by Ahmed Mohamed el-Sawalhy. Forums member: os008. 3nj0yz!


-- The MIT License 

-- Copyright (c) 2009 Ahmed el-Sawalhy

-- Permission is hereby granted, free of charge, to any person obtaining a copy
-- of this software and associated documentation files (the "Software"), to deal
-- in the Software without restriction, including without limitation the rights
-- to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is
-- furnished to do so, subject to the following conditions: 

-- The above copyright notice and this permission notice shall be included in
-- all copies or substantial portions of the Software. 

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
-- IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-- FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
-- AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-- LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
-- OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
-- THE SOFTWARE. 


function acsHealStart()	-- Heal Other

	-- When we are switching target to heal ourselves, do not interrupt
	if( SimpleTimer.acsCombatTempSwitchTarget ) then return end

	if ( acsPreCastChecks() ) then
		-- Healing skill 1-20, check every healing skill when we are healing others
		for i=1,20 do
			-- 1. Check this skill slot is valid or not
			if ( acsPvEHealSlot[i] and acsPvEHealSlot[i]~="" and acsPvEHealEnabled[i] and acsPvEHealOthers[i] ) then
				-- 2. Check this skill slot is available or not, otherwise it is still in cooldown
				if ( GetActionUsable( acsPvEHealSlot[i] ) ) then
					-- 3a. Check your target's current HP ratio
					if( ( ( ( ( math.ceil(UnitHealth("target")) )/UnitMaxHealth("target") )*100 )<=( acsPvEHealPercent[i] ) ) and ( not acsDebuffTargetCheck("cursed") ) ) then
						if ( acsPvEHealBuff[i] and acsPvEHealBuff[i]~="<Heal Buff>" and  acsPvEHealBuff[i]~="" ) then
							if ( not acsBuffTargetCheck(acsPvEHealBuff[i]) ) then
								acsCast( acsPvEHealSlot[i],false,0 );
								return;
							end
						else
							if ( acsPvEHealBuff[i]=="<Heal Buff>" or acsPvEHealBuff[i]=="" or ( not acsPvEHealBuff[i] ) ) then
								acsCast( acsPvEHealSlot[i],false,0 );
								return;
							end
						end
					-- 3b. Check your current HP ratio
					elseif( ( ( ( ( math.ceil(UnitHealth("player")) )/UnitMaxHealth("player") )*100 )<=( acsPvEHealPercent[i] ) ) and ( not acsDebuffTargetCheck("cursed") ) ) then
						if ( acsPvEHealBuff[i] and acsPvEHealBuff[i]~="<Heal Buff>" and  acsPvEHealBuff[i]~="" ) then
							-- check if the Heal over Time(HoT) buff is still there
							if ( not acsBuffPlayerCheck(acsPvEHealBuff[i]) ) then	
								--DEFAULT_CHAT_FRAME:AddMessage("Rescue myself!!!");
								local focus_id = acsGetAvailableFocusNumber();
								SimpleTimer.acsCombatTempSwitchTarget=true;
								FocusUnit( focus_id, "target");
								TargetUnit("player");
								acsCast( acsPvEHealSlot[i],false,0 );
								TargetUnit( "focus"..tostring(focus_id) );
								FocusUnit( focus_id, "");
								SimpleTimer.acsCombatTempSwitchTarget=false;
								return;
							end
						else
							if ( acsPvEHealBuff[i]=="<Heal Buff>" or acsPvEHealBuff[i]=="" or ( not acsPvEHealBuff[i] ) ) then
								local focus_id = acsGetAvailableFocusNumber();
								SimpleTimer.acsCombatTempSwitchTarget=true;
								FocusUnit( focus_id, "target");
								TargetUnit("player");
								acsCast( acsPvEHealSlot[i],false,0 );
								TargetUnit( "focus"..tostring(focus_id) );
								FocusUnit( focus_id, "");
								SimpleTimer.acsCombatTempSwitchTarget=false;
								return;
							end
						end
					-- 3c. Check group HP ratio (further feature)
					else
					end
				end
			end
		end
		
		-- HP Potion (Heal Other), check to see if we should drink HP potion when we are healing others
		for i=1,2 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsPvEHealthPotionSlot[i] );
			
			if ( acsPvEHealthPotionSlot[i] and acsPvEHealthPotionSlot[i]~="" and acsPvEHealthPotionEnabled[i] ) then
				if ( PotionCCD<=0 and ( ( ( UnitHealth("player")/UnitMaxHealth("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
					if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
						if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
							acsCast( acsPvEHealthPotionSlot[i],false,0 );
						end
					else
						if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
							acsCast( acsPvEHealthPotionSlot[i],false,0 );
						end
					end
				end
			end
		end

		-- MP potion (Heal Other), check to see if we should drink MP potion when we are healing others
		for i=3,4 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsPvEHealthPotionSlot[i] );
			
			if ( acsPvEHealthPotionSlot[i] and acsPvEHealthPotionSlot[i]~="" and acsPvEHealthPotionEnabled[i] ) then
				if ( acsClass==acsPriest or acsClass==acsMage or acsClass==acsKnight or acsClass==acsWarden or acsClass==acsDruid ) then
					if ( PotionCCD<=0 and ( ( ( UnitMana("player")/UnitMaxMana("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
						if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
							if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
								acsCast( acsPvEHealthPotionSlot[i],false,0 );
							end
						else
							if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
								acsCast( acsPvEHealthPotionSlot[i],false,0 );
							end
						end
					end
				else
					if ( ( acsClass2==acsPriest or acsClass2==acsMage or acsClass2==acsKnight or acsClass2==acsWarden or acsClass2==acsDruid ) and ( acsClass~=acsPriest or acsClass~=acsMage or acsClass~=acsKnight or acsClass~=acsWarden or acsClass~=acsDruid ) ) then
						if ( PotionCCD<=0 and ( ( ( UnitSkill("player")/UnitMaxSkill("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
							if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
								if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
									acsCast( acsPvEHealthPotionSlot[i],false,0 );
								end
							else
								if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
									acsCast( acsPvEHealthPotionSlot[i],false,0 );
								end
							end
						end
					end
				end
			end
		end
		
	end

end


function acsCombatStart()
	--DEFAULT_CHAT_FRAME:AddMessage("acsCombatStart()");
	if ( acsPreCastChecks() ) then

		-- Heal (PvE)
		for i=1,20 do
			if ( acsPvEHealSlot[i] and acsPvEHealSlot[i]~="" and acsPvEHealEnabled[i] ) then
				if ( GetActionUsable( acsPvEHealSlot[i] ) and ( ( ( UnitHealth("player")/UnitMaxHealth("player") )*100 )<=( acsPvEHealPercent[i] ) ) and ( not acsDebuffPlayerCheck("cursed") ) ) then
					if ( acsPvEHealBuff[i] and acsPvEHealBuff[i]~="<Heal Buff>" and  acsPvEHealBuff[i]~="" ) then
						if ( not acsBuffPlayerCheck(acsPvEHealBuff[i]) ) then
							acsCast( acsPvEHealSlot[i],false,0 );
							return;
						end
					else
						if ( acsPvEHealBuff[i]=="<Heal Buff>" or acsPvEHealBuff[i]=="" or ( not acsPvEHealBuff[i] ) ) then
							acsCast( acsPvEHealSlot[i],false,0 );
							return;
						end
					end
				end
			end
		end

		-- HP potion (PvE)
		for i=1,2 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsPvEHealthPotionSlot[i] );
			
			if ( acsPvEHealthPotionSlot[i] and acsPvEHealthPotionSlot[i]~="" and acsPvEHealthPotionEnabled[i] ) then
				if ( PotionCCD<=0 and ( ( ( UnitHealth("player")/UnitMaxHealth("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
					if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
						if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
							acsCast( acsPvEHealthPotionSlot[i],false,0 );
						end
					else
						if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
							acsCast( acsPvEHealthPotionSlot[i],false,0 );
						end
					end
				end
			end
		end

		-- MP potion (PvE)
		for i=3,4 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsPvEHealthPotionSlot[i] );
			
			if ( acsPvEHealthPotionSlot[i] and acsPvEHealthPotionSlot[i]~="" and acsPvEHealthPotionEnabled[i] ) then
				if ( acsClass==acsPriest or acsClass==acsMage or acsClass==acsKnight or acsClass==acsWarden or acsClass==acsDruid ) then
					if ( PotionCCD<=0 and ( ( ( UnitMana("player")/UnitMaxMana("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
						if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
							if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
								acsCast( acsPvEHealthPotionSlot[i],false,0 );
							end
						else
							if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
								acsCast( acsPvEHealthPotionSlot[i],false,0 );
							end
						end
					end
				else
					if ( ( acsClass2==acsPriest or acsClass2==acsMage or acsClass2==acsKnight or acsClass2==acsWarden or acsClass2==acsDruid) and ( acsClass~=acsPriest or acsClass~=acsMage or acsClass~=acsKnight or acsClass~=acsWarden or acsClass~=acsDruid) ) then
						if ( PotionCCD<=0 and ( ( ( UnitSkill("player")/UnitMaxSkill("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
							if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
								if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
									acsCast( acsPvEHealthPotionSlot[i],false,0 );
								end
							else
								if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
									acsCast( acsPvEHealthPotionSlot[i],false,0 );
								end
							end
						end
					end
				end
			end
		end

		-- Buff when in Combat (PvE)
		for i=1,20 do
			if ( acsPvEBuffSlot[i] and acsPvEBuffSlot[i]~="" and acsPvEBuffEnabled[i] and acsPvEBuffCombat[i] ) then
				if ( GetActionUsable( acsPvEBuffSlot[i] ) ) then
					if ( acsPvEBuffName[i] and acsPvEBuffName[i]~="<Buff>" and acsPvEBuffName[i]~="" ) then
						-- with '!' means player don't have this debuff
						if ( string.find( string.lower(acsPvEBuffName[i]),"!" ) ) then
							local acsTempDebuffName=string.sub(acsPvEBuffName[i],2);
							if ( not ( acsDebuffPlayerCheck(acsTempDebuffName) ) ) then
								acsCast( acsPvEBuffSlot[i],false,0 );
								return;
							end
						-- with '*' means player or target have this debuff
						elseif ( string.find( string.lower(acsPvEBuffName[i]),"*" ) ) then
							local acsTempDebuffName=string.sub(acsPvEBuffName[i],2);
							-- Debuff (Self)
							if ( UnitName("target")==UnitName("player") or UnitName("target")=="" or UnitName("target")==nil ) then
								if ( acsDebuffPlayerCheck(acsTempDebuffName) ) then
									acsCast( acsPvEBuffSlot[i],false,0 );
									return;
								end
							-- Debuff (Other)
							elseif ( UnitIsPlayer("target") and UnitName("target")~=UnitName("player") ) then
								if ( acsDebuffTargetCheck(acsTempDebuffName) ) then
									acsCast( acsPvEBuffSlot[i],false,0 );
									return;
								end
							end
						elseif ( not ( acsBuffPlayerCheck(acsPvEBuffName[i]) ) ) then
							acsCast( acsPvEBuffSlot[i],false,0 );
							return;
						end
					end
				end
			end
		end

		-- Skill (PvE)
		if ( inOrderCasting ) then
			for i=1,20 do
				if ( acsPvESkillSlot[i] and acsPvESkillSlot[i]~="" and acsPvESkillSlot[i]~=0 and acsPvESkillEnabled[i] ) then
					if ( GetActionUsable( acsPvESkillSlot[i] ) ) then
						acsGlobalCD=false;
						break;
					else
						if ( acsPvEAttackEnabled and useMeleeAttack ) then
							acsCast( acsPvEAttackSlot,false,0 );
						end
						acsGlobalCD=true;
					end
				end
			end
		end

		if ( ( not acsGlobalCD ) or ( not inOrderCasting ) ) then
			for i=acsIndex,20 do
				if ( acsPvESkillSlot[i] and acsPvESkillSlot[i]~="" and acsPvESkillSlot[i]~=0 and acsPvESkillEnabled[i] ) then
					if ( GetActionUsable( acsPvESkillSlot[i] ) ) then
						if ( acsPvESkillPercentHP[i] ) then
							if ( string.find( string.lower(acsPvESkillHP[i]),"!" ) ) then
								local acsTempHPNum = tonumber( string.sub(acsPvESkillHP[i],2) );
								if ( ( ( ( math.ceil(UnitHealth("target")) )/UnitMaxHealth("target") )*100 ) <= ( acsTempHPNum ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							else
								acsPvESkillHP[i] = tonumber( acsPvESkillHP[i] );
								if ( ( ( ( math.ceil(UnitHealth("target")) )/UnitMaxHealth("target") )*100 ) >= ( acsPvESkillHP[i] ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							end
						else
							if ( string.find( string.lower(acsPvESkillHP[i]),"!" ) ) then
								local acsTempHPNum = tonumber( string.sub(acsPvESkillHP[i],2) );
								if ( ( ( math.ceil(UnitHealth("target")) ) <= ( acsTempHPNum ) ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							else
								acsPvESkillHP[i] = tonumber( acsPvESkillHP[i] );
								if ( ( ( math.ceil(UnitHealth("target")) ) >= ( acsPvESkillHP[i] ) ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							end
						end
						
						if ( acsPvESkillPercentMP[i] ) then
							if ( string.find( string.lower(acsPvESkillMP[i]),"!" ) ) then
								local acsTempMPNum = tonumber( string.sub(acsPvESkillMP[i],2) );
								if ( ( ( ( math.ceil(UnitMana("player")) )/UnitMaxMana("player") )*100 ) <= ( acsTempMPNum ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							else
								acsPvESkillMP[i] = tonumber( acsPvESkillMP[i] );
								if ( ( ( ( math.ceil(UnitMana("player")) )/UnitMaxMana("player") )*100 ) >= ( acsPvESkillMP[i] ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							end
						else
							if ( string.find( string.lower(acsPvESkillMP[i]),"!" ) ) then
								local acsTempMPNum = tonumber( string.sub(acsPvESkillMP[i],2) );
								if ( ( ( math.ceil(UnitMana("player")) ) <= ( acsTempMPNum ) ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							else
								acsPvESkillMP[i] = tonumber( acsPvESkillMP[i] );
								if ( ( ( math.ceil(UnitMana("player")) ) >= ( acsPvESkillMP[i] ) ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							end
						end
						
						if ( acsTempHPGo and acsTempMPGo ) then
							if ( acsPvESkillCheck1[i] and acsPvESkillCheck1[i]~="<De/Buff>" and acsPvESkillCheck1[i]~="" and acsPvESkillExist1[i] ) then
								if ( string.find( string.lower(acsPvESkillCheck1[i]),"!" ) ) then
									local acsTempBuffName=string.sub(acsPvESkillCheck1[i],2);
									if ( acsBuffPlayerCheck(acsTempBuffName) ) then
										acsTempCastGo1=true;
									else
										acsTempCastGo1=false;
									end
								else
									if ( acsDebuffTargetCheck(acsPvESkillCheck1[i]) ) then
										acsTempCastGo1=true;
									else
										acsTempCastGo1=false;
									end
								end
							else
								if ( acsPvESkillCheck1[i] and acsPvESkillCheck1[i]~="<De/Buff>" and acsPvESkillCheck1[i]~="" ) then
									if ( string.find( string.lower(acsPvESkillCheck1[i]),"!" ) ) then
										local acsTempBuffName=string.sub(acsPvESkillCheck1[i],2);
										if ( not ( acsBuffPlayerCheck(acsTempBuffName) ) ) then
											acsTempCastGo1=true;
										else
											acsTempCastGo1=false;
										end
									else
										if ( not ( acsDebuffTargetCheck(acsPvESkillCheck1[i]) ) ) then
											acsTempCastGo1=true;
										else
											acsTempCastGo1=false;
										end
									end
								else
									if ( acsPvESkillCheck1[i]=="<De/Buff>" or acsPvESkillCheck1[i]=="" ) then
										acsTempCastGo1=true;
									end
								end
							end
							
							if ( acsPvESkillCheck2[i] and acsPvESkillCheck2[i]~="<De/Buff>" and acsPvESkillCheck2[i]~="" and acsPvESkillExist2[i] ) then
								if ( string.find( string.lower(acsPvESkillCheck2[i]),"!" ) ) then
									local acsTempBuffName=string.sub(acsPvESkillCheck2[i],2);
									if ( acsBuffPlayerCheck(acsTempBuffName) ) then
										acsTempCastGo2=true;
									else
										acsTempCastGo2=false;
									end
								else
									if ( acsDebuffTargetCheck(acsPvESkillCheck2[i]) ) then
										acsTempCastGo2=true;
									else
										acsTempCastGo2=false;
									end
								end
							else
								if ( acsPvESkillCheck2[i] and acsPvESkillCheck2[i]~="<De/Buff>" and acsPvESkillCheck2[i]~="" ) then
									if ( string.find( string.lower(acsPvESkillCheck2[i]),"!" ) ) then
										local acsTempBuffName=string.sub(acsPvESkillCheck2[i],2);
										if ( not ( acsBuffPlayerCheck(acsTempBuffName) ) ) then
											acsTempCastGo2=true;
										else
											acsTempCastGo2=false;
										end
									else
										if ( not ( acsDebuffTargetCheck(acsPvESkillCheck2[i]) ) ) then
											acsTempCastGo2=true;
										else
											acsTempCastGo2=false;
										end
									end
								else
									if ( acsPvESkillCheck2[i]=="<De/Buff>" or acsPvESkillCheck2[i]=="" ) then
										acsTempCastGo2=true;
									end
								end
							end

							if ( acsTempCastGo1 and acsTempCastGo2 ) then
								acsCast( acsPvESkillSlot[i],true,i,acsPvESkillStopMove[i] );
								return;
							end
						end
					end
					if ( inOrderCasting ) then
						acsIndex=i+1;
					end
				end
				if ( i==20 and inOrderCasting ) then
					acsIndex=1;
				end
			end
			if ( acsPvEAttackEnabled and useMeleeAttack ) then
				acsCast( acsPvEAttackSlot,false,0 );
			end
		end
	end
	
end


function acsCombatPvPStart()
	
	if ( acsPreCastChecks() ) then
		-- Self-Healing (PvP)
		for i=1,20 do
			if ( acsHealPvPSlot[i] and acsHealPvPSlot[i]~="" and acsHealPvPEnabled[i] ) then
				if ( GetActionUsable( acsHealPvPSlot[i] ) and ( ( ( UnitHealth("player")/UnitMaxHealth("player") )*100 )<=( acsHealPvPPercent[i] ) ) and ( not acsDebuffPlayerCheck("cursed") ) ) then
					if ( acsHealPvPBuff[i] and acsHealPvPBuff[i]~="<Heal Buff>" and  acsHealPvPBuff[i]~="" ) then
						if ( not acsBuffPlayerCheck(acsHealPvPBuff[i]) ) then
							acsCast( acsHealPvPSlot[i],false,0 );
							return;
						end
					else
						if ( acsHealPvPBuff[i]=="<Heal Buff>" or acsHealPvPBuff[i]=="" or ( not acsHealPvPBuff[i] ) ) then
							acsCast( acsHealPvPSlot[i],false,0 );
							return;
						end
					end
				end
			end
		end

		-- HP potion (PvP)
		for i=1,2 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsHealthPvPPotionSlot[i] );
			
			if ( acsHealthPvPPotionSlot[i] and acsHealthPvPPotionSlot[i]~="" and acsHealthPvPPotionEnabled[i] ) then
				if ( PotionCCD<=0 and ( ( ( UnitHealth("player")/UnitMaxHealth("player") )*100 )<=( acsHealthPvPPotionPercent[i] ) ) ) then
					if ( acsHealthPvPPotionBuff[i] and acsHealthPvPPotionBuff[i]~="<Potion Buff>" and  acsHealthPvPPotionBuff[i]~="" ) then
						if ( not acsBuffPlayerCheck(acsHealthPvPPotionBuff[i]) ) then
							acsCast( acsHealthPvPPotionSlot[i],false,0 );
						end
					else
						if ( acsHealthPvPPotionBuff[i]=="<Potion Buff>" or acsHealthPvPPotionBuff[i]=="" or ( not acsHealthPvPPotionBuff[i] ) ) then
							acsCast( acsHealthPvPPotionSlot[i],false,0 );
						end
					end
				end
			end
		end

		-- MP potion (PvP)
		for i=3,4 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsHealthPvPPotionSlot[i] );
			
			if ( acsHealthPvPPotionSlot[i] and acsHealthPvPPotionSlot[i]~="" and acsHealthPvPPotionEnabled[i] ) then
				if ( acsClass==acsPriest or acsClass==acsMage or acsClass==acsKnight or acsClass==acsWarden or acsClass==acsDruid ) then
					if ( PotionCCD<=0 and ( ( ( UnitMana("player")/UnitMaxMana("player") )*100 )<=( acsHealthPvPPotionPercent[i] ) ) ) then
						if ( acsHealthPvPPotionBuff[i] and acsHealthPvPPotionBuff[i]~="<Potion Buff>" and  acsHealthPvPPotionBuff[i]~="" ) then
							if ( not acsBuffPlayerCheck(acsHealthPvPPotionBuff[i]) ) then
								acsCast( acsHealthPvPPotionSlot[i],false,0 );
							end
						else
							if ( acsHealthPvPPotionBuff[i]=="<Potion Buff>" or acsHealthPvPPotionBuff[i]=="" or ( not acsHealthPvPPotionBuff[i] ) ) then
								acsCast( acsHealthPvPPotionSlot[i],false,0 );
							end
						end
					end
				else
					if ( ( acsClass2==acsPriest or acsClass2==acsMage or acsClass2==acsKnight or acsClass2==acsWarden or acsClass2==acsDruid) and ( acsClass~=acsPriest or acsClass~=acsMage or acsClass~=acsKnight or acsClass~=acsWarden or acsClass~=acsDruid) ) then
						if ( PotionCCD<=0 and ( ( ( UnitSkill("player")/UnitMaxSkill("player") )*100 )<=( acsHealthPvPPotionPercent[i] ) ) ) then
							if ( acsHealthPvPPotionBuff[i] and acsHealthPvPPotionBuff[i]~="<Potion Buff>" and  acsHealthPvPPotionBuff[i]~="" ) then
								if ( not acsBuffPlayerCheck(acsHealthPvPPotionBuff[i]) ) then
									acsCast( acsHealthPvPPotionSlot[i],false,0 );
								end
							else
								if ( acsHealthPvPPotionBuff[i]=="<Potion Buff>" or acsHealthPvPPotionBuff[i]=="" or ( not acsHealthPvPPotionBuff[i] ) ) then
									acsCast( acsHealthPvPPotionSlot[i],false,0 );
								end
							end
						end
					end
				end
			end
		end

		-- Buff/Debuff (PvP)
		for i=1,20 do
			if ( acsBuffPvPSlot[i] and acsBuffPvPSlot[i]~="" and acsBuffPvPEnabled[i] and acsBuffPvPCombat[i] ) then
				if ( GetActionUsable( acsBuffPvPSlot[i] ) ) then
					if ( acsBuffPvPName[i] and acsBuffPvPName[i]~="<Buff>" and acsBuffPvPName[i]~="" ) then
						-- with '!' means player don't have this debuff
						if ( string.find( string.lower(acsPvEBuffName[i]),"!" ) ) then
							local acsTempDebuffName=string.sub(acsPvEBuffName[i],2);
							if ( not ( acsDebuffPlayerCheck(acsTempDebuffName) ) ) then
								acsCast( acsPvEBuffSlot[i],false,0 );
								return;
							end
						-- with '*' means player or target have this debuff
						elseif ( string.find( string.lower(acsPvEBuffName[i]),"*" ) ) then
							local acsTempDebuffName=string.sub(acsPvEBuffName[i],2);
							-- Debuff (Self)
							if ( UnitName("target")==UnitName("player") or UnitName("target")=="" or UnitName("target")==nil ) then
								if ( acsDebuffPlayerCheck(acsTempDebuffName) ) then
									acsCast( acsPvEBuffSlot[i],false,0 );
									return;
								end
							-- Debuff (Other)
							elseif ( UnitIsPlayer("target") and UnitName("target")~=UnitName("player") ) then
								if ( acsDebuffTargetCheck(acsTempDebuffName) ) then
									acsCast( acsPvEBuffSlot[i],false,0 );
									return;
								end
							end
						elseif ( not ( acsBuffPlayerCheck(acsBuffPvPName[i]) ) ) then
							acsCast( acsBuffPvPSlot[i],false,0 );
							return;
						end
					end
				end
			end
		end
		
		if ( inOrderCasting ) then
			for i=1,20 do
				if ( acsPvPSkillSlot[i] and acsPvPSkillSlot[i]~="" and acsPvPSkillSlot[i]~=0 and acsPvPSkillEnabled[i] ) then
					if ( GetActionUsable( acsPvPSkillSlot[i] ) ) then
						acsGlobalCD=false;
						break;
					else
						if ( acsPvPAttackEnabled and useMeleeAttack ) then
							acsCast( acsAttackPvPSlot,false,0 );
						end
						acsGlobalCD=true;
					end
				end
			end
		end
		
		if ( ( not acsGlobalCD ) or ( not inOrderCasting ) ) then
			for i=acsIndex,20 do
				if ( acsPvPSkillSlot[i] and acsPvPSkillSlot[i]~="" and acsPvPSkillSlot[i]~=0 and acsPvPSkillEnabled[i] ) then
					if ( GetActionUsable( acsPvPSkillSlot[i] ) ) then
						if ( acsPvPSkillPercentHP[i] ) then
							if ( string.find( string.lower(acsPvPSkillHP[i]),"!" ) ) then
								local acsTempHPNum = tonumber( string.sub(acsPvPSkillHP[i],2) );
								if ( ( ( ( math.ceil(UnitHealth("target")) )/UnitMaxHealth("target") )*100 ) <= ( acsTempHPNum ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							else
								acsPvPSkillHP[i] = tonumber( acsPvPSkillHP[i] );
								if ( ( ( ( math.ceil(UnitHealth("target")) )/UnitMaxHealth("target") )*100 ) >= ( acsPvPSkillHP[i] ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							end
						else
							if ( string.find( string.lower(acsPvPSkillHP[i]),"!" ) ) then
								local acsTempHPNum = tonumber( string.sub(acsPvPSkillHP[i],2) );
								if ( ( ( math.ceil(UnitHealth("target")) ) <= ( acsTempHPNum ) ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							else
								acsPvPSkillHP[i] = tonumber( acsPvPSkillHP[i] );
								if ( ( ( math.ceil(UnitHealth("target")) ) >= ( acsPvPSkillHP[i] ) ) ) then
									acsTempHPGo=true;
								else
									acsTempHPGo=false;
								end
							end
						end
						
						if ( acsPvPSkillPercentMP[i] ) then
							if ( string.find( string.lower(acsPvPSkillMP[i]),"!" ) ) then
								local acsTempMPNum = tonumber( string.sub(acsPvPSkillMP[i],2) );
								if ( ( ( ( math.ceil(UnitMana("player")) )/UnitMaxMana("player") )*100 ) <= ( acsTempMPNum ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							else
								acsPvPSkillMP[i] = tonumber( acsPvPSkillMP[i] );
								if ( ( ( ( math.ceil(UnitMana("player")) )/UnitMaxMana("player") )*100 ) >= ( acsPvPSkillMP[i] ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							end
						else
							if ( string.find( string.lower(acsPvPSkillMP[i]),"!" ) ) then
								local acsTempMPNum = tonumber( string.sub(acsPvPSkillMP[i],2) );
								if ( ( ( math.ceil(UnitMana("player")) ) <= ( acsTempMPNum ) ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							else
								acsPvPSkillMP[i] = tonumber( acsPvPSkillMP[i] );
								if ( ( ( math.ceil(UnitMana("player")) ) >= ( acsPvPSkillMP[i] ) ) ) then
									acsTempMPGo=true;
								else
									acsTempMPGo=false;
								end
							end
						end
						
						if ( acsTempHPGo and acsTempMPGo ) then
							if ( acsPvPSkillCheck1[i] and acsPvPSkillCheck1[i]~="<De/Buff>" and acsPvPSkillCheck1[i]~="" and acsPvPSkillExist1[i] ) then
								if ( string.find( string.lower(acsPvPSkillCheck1[i]),"!" ) ) then
									local acsTempBuffName=string.sub(acsPvPSkillCheck1[i],2);
									if ( acsBuffPlayerCheck(acsTempBuffName) ) then
										acsTempCastGo1=true;
									else
										acsTempCastGo1=false;
									end
								else
									if ( acsDebuffTargetCheck(acsPvPSkillCheck1[i]) ) then
										acsTempCastGo1=true;
									else
										acsTempCastGo1=false;
									end
								end
							else
								if ( acsPvPSkillCheck1[i] and acsPvPSkillCheck1[i]~="<De/Buff>" and acsPvPSkillCheck1[i]~="" ) then
									if ( string.find( string.lower(acsPvPSkillCheck1[i]),"!" ) ) then
										local acsTempBuffName=string.sub(acsPvPSkillCheck1[i],2);
										if ( not ( acsBuffPlayerCheck(acsTempBuffName) ) ) then
											acsTempCastGo1=true;
										else
											acsTempCastGo1=false;
										end
									else
										if ( not ( acsDebuffTargetCheck(acsPvPSkillCheck1[i]) ) ) then
											acsTempCastGo1=true;
										else
											acsTempCastGo1=false;
										end
									end
								else
									if ( acsPvPSkillCheck1[i]=="<De/Buff>" or acsPvPSkillCheck1[i]=="" ) then
										acsTempCastGo1=true;
									end
								end
							end
							
							if ( acsPvPSkillCheck2[i] and acsPvPSkillCheck2[i]~="<De/Buff>" and acsPvPSkillCheck2[i]~="" and acsPvPSkillExist2[i] ) then
								if ( string.find( string.lower(acsPvPSkillCheck2[i]),"!" ) ) then
									local acsTempBuffName=string.sub(acsPvPSkillCheck2[i],2);
									if ( acsBuffPlayerCheck(acsTempBuffName) ) then
										acsTempCastGo2=true;
									else
										acsTempCastGo2=false;
									end
								else
									if ( acsDebuffTargetCheck(acsPvPSkillCheck2[i]) ) then
										acsTempCastGo2=true;
									else
										acsTempCastGo2=false;
									end
								end
							else
								if ( acsPvPSkillCheck2[i] and acsPvPSkillCheck2[i]~="<De/Buff>" and acsPvPSkillCheck2[i]~="" ) then
									if ( string.find( string.lower(acsPvPSkillCheck2[i]),"!" ) ) then
										local acsTempBuffName=string.sub(acsPvPSkillCheck2[i],2);
										if ( not ( acsBuffPlayerCheck(acsTempBuffName) ) ) then
											acsTempCastGo2=true;
										else
											acsTempCastGo2=false;
										end
									else
										if ( not ( acsDebuffTargetCheck(acsPvPSkillCheck2[i]) ) ) then
											acsTempCastGo2=true;
										else
											acsTempCastGo2=false;
										end
									end
								else
									if ( acsPvPSkillCheck2[i]=="<De/Buff>" or acsPvPSkillCheck2[i]=="" ) then
										acsTempCastGo2=true;
									end
								end
							end

							if ( acsTempCastGo1 and acsTempCastGo2 ) then
								acsCast( acsPvPSkillSlot[i],true,i,acsPvPSkillStopMove[i] );
								return;
							end
						end
					end
					if ( inOrderCasting ) then
						acsIndex=i+1;
					end
				end
				if ( i==20 and inOrderCasting ) then
					acsIndex=1;
				end
			end
			if ( acsPvPAttackEnabled and useMeleeAttack ) then
				acsCast( acsPvPAttackSlot,false,0 );
			end
		end
	end
	
end

--[[
function acsBuffStuck()

	for i=1,20 do
		if ( acsPvEBuffSlot[i] and acsPvEBuffSlot[i]~="" and acsPvEBuffEnabled[i] and acsPvEBuffCombat[i] ) then
			if ( GetActionUsable( acsPvEBuffSlot[i] ) ) then
				if ( acsPvEBuffName[i] and acsPvEBuffName[i]~="<Buff>" and acsPvEBuffName[i]~="" ) then
					if ( not ( acsBuffPlayerCheck(acsPvEBuffName[i]) ) ) then
						acsCast( acsPvEBuffSlot[i],false,0 );
						return;
					end
				end
			end
		end
	end

end
--]]

function acsBuffStart()

	--SimpleTimer2.buffLock = true;
	
	if ( acsPreCastChecks() ) then
	
		-- Self-Healing (PvE)
		for i=1,20 do
			if ( acsPvEHealSlot[i] and acsPvEHealSlot[i]~="" and acsPvEHealEnabled[i] ) then
				if ( GetActionUsable( acsPvEHealSlot[i] ) and ( ( ( UnitHealth("player")/UnitMaxHealth("player") )*100 )<=( acsPvEHealPercent[i] ) ) and ( not acsDebuffPlayerCheck("cursed") ) ) then
					if ( acsPvEHealBuff[i] and acsPvEHealBuff[i]~="<Heal Buff>" and  acsPvEHealBuff[i]~="" ) then
						if ( not acsBuffPlayerCheck(acsPvEHealBuff[i]) ) then
							acsCast( acsPvEHealSlot[i],false,0 );
							return;
						end
					else
						if ( acsPvEHealBuff[i]=="<Heal Buff>" or acsPvEHealBuff[i]=="" or ( not acsPvEHealBuff[i] ) ) then
							acsCast( acsPvEHealSlot[i],false,0 );
							return;
						end
					end
				end
			end
		end

		-- HP potion (PvE)
		for i=1,2 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsPvEHealthPotionSlot[i] );
			
			if ( acsPvEHealthPotionOutEnabled[i] and acsPvEHealthPotionSlot[i] and acsPvEHealthPotionSlot[i]~="" and acsPvEHealthPotionEnabled[i] ) then
				if ( PotionCCD<=0 and ( ( ( UnitHealth("player")/UnitMaxHealth("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
					if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
						if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
							acsCast( acsPvEHealthPotionSlot[i],false,0 );
						end
					else
						if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
							acsCast( acsPvEHealthPotionSlot[i],false,0 );
						end
					end
				end
			end
		end

		-- MP potion (PvE)
		for i=3,4 do
			local PotionFCD, PotionCCD = GetActionCooldown( acsPvEHealthPotionSlot[i] );
			
			if ( acsPvEHealthPotionOutEnabled[i] and acsPvEHealthPotionSlot[i] and acsPvEHealthPotionSlot[i]~="" and acsPvEHealthPotionEnabled[i] ) then
				if ( acsClass==acsPriest or acsClass==acsMage or acsClass==acsKnight or acsClass==acsWarden or acsClass==acsDruid ) then
					if ( PotionCCD<=0 and ( ( ( UnitMana("player")/UnitMaxMana("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
						if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
							if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
								acsCast( acsPvEHealthPotionSlot[i],false,0 );
							end
						else
							if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
								acsCast( acsPvEHealthPotionSlot[i],false,0 );
							end
						end
					end
				else
					if ( ( acsClass2==acsPriest or acsClass2==acsMage or acsClass2==acsKnight or acsClass2==acsWarden or acsClass2==acsDruid ) and 
						 ( acsClass~=acsPriest or acsClass~=acsMage or acsClass~=acsKnight or acsClass~=acsWarden or acsClass~=acsDruid ) ) then
						if ( PotionCCD<=0 and ( ( ( UnitSkill("player")/UnitMaxSkill("player") )*100 )<=( acsPvEHealthPotionPercent[i] ) ) ) then
							if ( acsPvEHealthPotionBuff[i] and acsPvEHealthPotionBuff[i]~="<Potion Buff>" and  acsPvEHealthPotionBuff[i]~="" ) then
								if ( not acsBuffPlayerCheck(acsPvEHealthPotionBuff[i]) ) then
									acsCast( acsPvEHealthPotionSlot[i],false,0 );
								end
							else
								if ( acsPvEHealthPotionBuff[i]=="<Potion Buff>" or acsPvEHealthPotionBuff[i]=="" or ( not acsPvEHealthPotionBuff[i] ) ) then
									acsCast( acsPvEHealthPotionSlot[i],false,0 );
								end
							end
						end
					end
				end
			end
		end

		-- Buff/Debuff (PvE)
		for i=1,20 do
			if ( acsPvEBuffSlot[i] and acsPvEBuffSlot[i]~="" and acsPvEBuffEnabled[i] and ( not acsPvEBuffCombatOnly[i] ) ) then
				if ( GetActionUsable( acsPvEBuffSlot[i] ) ) then
					if ( acsPvEBuffName[i] and acsPvEBuffName[i]~="<Buff>" and acsPvEBuffName[i]~="" ) then
						-- with '!' means player don't have this debuff
						if ( string.find( string.lower(acsPvEBuffName[i]),"!" ) ) then
							local acsTempDebuffName=string.sub(acsPvEBuffName[i],2);
							if ( not ( acsDebuffPlayerCheck(acsTempDebuffName) ) ) then
								acsCast( acsPvEBuffSlot[i],false,0 );
								return;
							end
						-- with '*' means player or target have this debuff
						elseif ( string.find( string.lower(acsPvEBuffName[i]),"*" ) ) then
							local acsTempDebuffName=string.sub(acsPvEBuffName[i],2);
							-- Debuff (Self)
							if ( UnitName("target")==UnitName("player") or UnitName("target")=="" or UnitName("target")==nil ) then
								if ( acsDebuffPlayerCheck(acsTempDebuffName) ) then
									acsCast( acsPvEBuffSlot[i],false,0 );
									return;
								end
							-- Debuff (Other)
							elseif ( UnitIsPlayer("target") and UnitName("target")~=UnitName("player") ) then
								if ( acsDebuffTargetCheck(acsTempDebuffName) ) then
									acsCast( acsPvEBuffSlot[i],false,0 );
									return;
								end
							end
						elseif ( not ( acsBuffPlayerCheck(acsPvEBuffName[i]) ) ) then
							acsCast( acsPvEBuffSlot[i],false,0 );
							return;
						end
					else
						acsCast( acsPvEBuffSlot[i],false,0 );
						return;
					end
				end
			end
		end
		
	end

end

function acsBuffOthersStart()

	if ( acsPreCastChecks() ) then
	
		for i=1,20 do
			if ( acsPvEBuffSlot[i] and acsPvEBuffSlot[i]~="" and acsPvEBuffEnabled[i] and acsPvEBuffOthers[i] ) then
				if ( GetActionUsable( acsPvEBuffSlot[i] ) ) then
					if ( acsPvEBuffName[i] and acsPvEBuffName[i]~="<Buff>" and acsPvEBuffName[i]~="" ) then
						-- with '*' means your target have this debuff
						if ( string.find( string.lower(acsPvEBuffName[i]),"*" ) ) then
							local acsTempDebuffName=string.sub(acsPvEBuffName[i],2);
							-- Debuff (Other)
							if ( UnitIsPlayer("target") and UnitName("target")~=UnitName("player") ) then
								if ( acsDebuffTargetCheck(acsTempDebuffName) ) then
									acsCast( acsPvEBuffSlot[i],false,0 );
									return;
								end
							end
						elseif ( not ( acsBuffTargetCheck(acsPvEBuffName[i]) ) ) then
							-- Buff (Other)
							acsCast( acsPvEBuffSlot[i],false,0 );
							return;
						end
					else
						acsCast( acsPvEBuffSlot[i],false,0 );
						return;
					end
				end
			end
		end
		
	end
	
end

function acsCast(spellSlot,incrementFlag,currentIndex,spellStopMove)

	if ( inOrderCasting ) then
		acsJustCast=true;
		acsCurrentSpell=spellSlot;
	end

	if ( spellStopMove ) then
		MoveForwardStop();
	end
	
	UseAction(spellSlot);
	
	if ( incrementFlag and inOrderCasting ) then
		acsIndex=currentIndex+1;
	end
	
	-- DEFAULT_CHAT_FRAME:AddMessage("Use Action:"..spellSlot);
	
end

-- Check which focus slot is available to use, return value : 1~12
function acsGetAvailableFocusNumber()
	for i = 1 , 12 , 1 do
		if ( not UnitExists( "focus"..i ) ) then
			return i;
		end
	end
end

function acsPreCastChecks()

	if ( acsDebuffPlayerCheck(acsStun)==nil and acsDebuffPlayerCheck(acsShock)==nil and ( castStatus=="finished" or castStatus=="failed" or castStatus=="delayed" ) and ( castStatus2=="finished" or castStatus2=="failed" or castStatus2=="delayed" ) ) then
		return true;
	else
		return false;
	end
	
end

DEFAULT_CHAT_FRAME:AddMessage("|cffff0000CombatScript|r for UFAutoCS: on standby.", 0.8, 0.8, 1.0);