-- UberFlex AutoCombat System Configuration Panel.
-- Created by Ahmed Mohamed el-Sawalhy. Forums member: os008. 3nj0yz!


-- The MIT License 

-- Copyright (c) 2009 Ahmed el-Sawalhy

-- Permission is hereby granted, free of charge, to any person obtaining a copy
-- of this software and associated documentation files (the "Software"), to deal
-- in the Software without restriction, including without limitation the rights
-- to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is
-- furnished to do so, subject to the following conditions: 

-- The above copyright notice and this permission notice shall be included in
-- all copies or substantial portions of the Software. 

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
-- IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-- FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
-- AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-- LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
-- OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
-- THE SOFTWARE. 


function acsConfRunnerFrameOnLoad(this)

	acsConfVariablesLoaded = false;
	ACS_Vars_Loaded=false;
	
	if ( not acsFrameViewed ) then
		acsFrameViewed="Spells";
	end
	
	acsSpellHelpScreenOn=false;
	acsBuffsHelpScreenOn=false;
	acsHealsHelpScreenOn=false;
	acsPotionsHelpScreenOn=false;

	acsSlotsNumbersSpells=false;
	acsSlotsNumbersBuffs=false;
	acsSlotsNumbersHeals=false;
	acsSlotsNumbersPotions=false;

	SaveVariables("acs");

end


function acsConfRunnerFrameOnShow(this)

	acsConfRunnerFrame_VARIABLES_LOAD();
	
	if ( acs[acsPlayerName][acsClass]["ProfileSelected"]==1 ) then
		acsConfPanelFrame2CheckButton000_1:SetChecked(true);
		acsConfPanelFrame2CheckButton000_2:SetChecked(false);
		acsConfPanelFrame2CheckButton000_3:SetChecked(false);
		acsConfPanelFrameSpellsButton1_2:Show();
		acsConfPanelFrameSpellsButton1_3:Show();
		acsConfPanelFrameSpellsButton2_1:Hide();
		acsConfPanelFrameSpellsButton2_3:Hide();
		acsConfPanelFrameSpellsButton3_1:Hide();
		acsConfPanelFrameSpellsButton3_2:Hide();
	elseif ( acs[acsPlayerName][acsClass]["ProfileSelected"]==2 ) then
		acsConfPanelFrame2CheckButton000_1:SetChecked(false);
		acsConfPanelFrame2CheckButton000_2:SetChecked(true);
		acsConfPanelFrame2CheckButton000_3:SetChecked(false);
		acsConfPanelFrameSpellsButton1_2:Hide();
		acsConfPanelFrameSpellsButton1_3:Hide();
		acsConfPanelFrameSpellsButton2_1:Show();
		acsConfPanelFrameSpellsButton2_3:Show();
		acsConfPanelFrameSpellsButton3_1:Hide();
		acsConfPanelFrameSpellsButton3_2:Hide();
	else
		acsConfPanelFrame2CheckButton000_1:SetChecked(false);
		acsConfPanelFrame2CheckButton000_2:SetChecked(false);
		acsConfPanelFrame2CheckButton000_3:SetChecked(true);
		acsConfPanelFrameSpellsButton1_2:Hide();
		acsConfPanelFrameSpellsButton1_3:Hide();
		acsConfPanelFrameSpellsButton2_1:Hide();
		acsConfPanelFrameSpellsButton2_3:Hide();
		acsConfPanelFrameSpellsButton3_1:Show();
		acsConfPanelFrameSpellsButton3_2:Show();
	end
	
	if ( acsFrameViewed=="Spells" ) then
		acsConfPanelFrameSpells:Show();
		acsConfPanelFrameHeals:Hide();
		acsConfPanelFrameBuffs:Hide();
		acsConfPanelFrameHealthPotions:Hide();
	end

	if ( acsFrameViewed=="Heals" ) then
		acsConfPanelFrameSpells:Hide();
		acsConfPanelFrameHeals:Show();
		acsConfPanelFrameBuffs:Hide();
		acsConfPanelFrameHealthPotions:Hide();
	end

	if ( acsFrameViewed=="Buffs" ) then
		acsConfPanelFrameSpells:Hide();
		acsConfPanelFrameHeals:Hide();
		acsConfPanelFrameBuffs:Show();
		acsConfPanelFrameHealthPotions:Hide();
	end

	if ( acsFrameViewed=="Potions" ) then
		acsConfPanelFrameSpells:Hide();
		acsConfPanelFrameHeals:Hide();
		acsConfPanelFrameBuffs:Hide();
		acsConfPanelFrameHealthPotions:Show();
	end

	acsConfPanelFrame2Version:SetText("v13.06.7032");

	acsUpdateMainframe();
	
end

function acsVariables()

	if ( ( not acsPlayerName ) or acsPlayerName~=UnitName("player") ) then
		if ( UnitName("player") ) then
			acsPlayerName=UnitName("player");
		else
			return;
		end
	end

	if ( ( not acsClass ) or acsClass~=UnitClass("player") ) then
		if ( UnitClass("player") ) then
			acsClass, acsClass2=UnitClass("player");
		else
			return;
		end
	end

	if ( acsConfVariablesLoaded ) then

		if ( acs[acsPlayerName][acsClass]["ProfileSelected"]==3 ) then
			acsProfiler=1;
		else
			acsProfiler = acs[acsPlayerName][acsClass]["ProfileSelected"];
		end
		
		tickRateSecs=tonumber(acs[acsPlayerName][acsClass]["TickRate"]);
		
		inOrderCasting=acs[acsPlayerName][acsClass]["InOrderCast"];
		priorityCasting=acs[acsPlayerName][acsClass]["PriorityCast"];
		
		acsIcon=acs[acsPlayerName][acsClass]["IconShow"];
		acsSingleSwitch=acs[acsPlayerName][acsClass]["OneSwitch"];
		acsManualSwitch=acs[acsPlayerName][acsClass]["Manual"];
		
		acsLoot=acs[acsPlayerName][acsClass]["Loot"][acsProfiler];
		
		acsPvESkillSlot={};
		acsPvESkillEnabled={};
		acsPvESkillCheck1={};
		acsPvESkillExist1={};
		acsPvESkillCheck2={};
		acsPvESkillExist2={};
		acsPvESkillHP={};
		acsPvESkillPercentHP={};
		acsPvESkillMP={};
		acsPvESkillPercentMP={};
		acsPvESkillStopMove={};
		
		acsPvEAttackEnabled=acs[acsPlayerName][acsClass]["AttackEnabled"][acsProfiler];
		acsPvEAttackSlot=tonumber(acs[acsPlayerName][acsClass]["AttackSlot"][acsProfiler]);
		
		for indexer = 1,20 do
			acsPvESkillSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["SkillSlot"][acsProfiler][indexer]);
			acsPvESkillEnabled[indexer]=acs[acsPlayerName][acsClass]["SkillEnabled"][acsProfiler][indexer];
			acsPvESkillCheck1[indexer]=acs[acsPlayerName][acsClass]["SkillCheck1"][acsProfiler][indexer];
			acsPvESkillExist1[indexer]=acs[acsPlayerName][acsClass]["SkillExist1"][acsProfiler][indexer];
			acsPvESkillCheck2[indexer]=acs[acsPlayerName][acsClass]["SkillCheck2"][acsProfiler][indexer];
			acsPvESkillExist2[indexer]=acs[acsPlayerName][acsClass]["SkillExist2"][acsProfiler][indexer];
			acsPvESkillHP[indexer]=acs[acsPlayerName][acsClass]["SkillHP"][acsProfiler][indexer];
			acsPvESkillPercentHP[indexer]=acs[acsPlayerName][acsClass]["SkillPercentHP"][acsProfiler][indexer];
			acsPvESkillMP[indexer]=acs[acsPlayerName][acsClass]["SkillMP"][acsProfiler][indexer];
			acsPvESkillPercentMP[indexer]=acs[acsPlayerName][acsClass]["SkillPercentMP"][acsProfiler][indexer];
			acsPvESkillStopMove[indexer]=acs[acsPlayerName][acsClass]["SkillStopMove"][acsProfiler][indexer];
		end

		acsPvEBuffSlot={};
		acsPvEBuffEnabled={};
		acsPvEBuffName={};
		acsPvEBuffCombat={};
		acsPvEBuffCombatOnly={};
		acsPvEBuffOthers={};
		
		for indexer = 1,20 do
			acsPvEBuffSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["BuffSlot"][acsProfiler][indexer]);
			acsPvEBuffEnabled[indexer]=acs[acsPlayerName][acsClass]["BuffEnabled"][acsProfiler][indexer];
			acsPvEBuffName[indexer]=acs[acsPlayerName][acsClass]["BuffName"][acsProfiler][indexer];
			acsPvEBuffCombat[indexer]=acs[acsPlayerName][acsClass]["BuffCombat"][acsProfiler][indexer];
			acsPvEBuffCombatOnly[indexer]=acs[acsPlayerName][acsClass]["BuffCombatOnly"][acsProfiler][indexer];
			acsPvEBuffOthers[indexer]=acs[acsPlayerName][acsClass]["BuffOthers"][acsProfiler][indexer];
		end

		acsPvEHealSlot={};
		acsPvEHealEnabled={};
		acsPvEHealBuff={};
		acsPvEHealPercent={};
		acsPvEHealOthers={};
		
		for indexer = 1,20 do
			acsPvEHealSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealSlot"][acsProfiler][indexer]);
			acsPvEHealEnabled[indexer]=acs[acsPlayerName][acsClass]["HealEnabled"][acsProfiler][indexer];
			acsPvEHealBuff[indexer]=acs[acsPlayerName][acsClass]["HealBuff"][acsProfiler][indexer];
			acsPvEHealPercent[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealPercent"][acsProfiler][indexer]);
			acsPvEHealOthers[indexer]=acs[acsPlayerName][acsClass]["HealOthers"][acsProfiler][indexer];
		end

		acsPvEHealthPotionSlot={};
		acsPvEHealthPotionEnabled={};
		acsPvEHealthPotionBuff={};
		acsPvEHealthPotionPercent={};
		acsPvEHealthPotionOutEnabled={};
		
		for indexer = 1,4 do
			acsPvEHealthPotionSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealthPotionSlot"][acsProfiler][indexer]);
			acsPvEHealthPotionEnabled[indexer]=acs[acsPlayerName][acsClass]["HealthPotionEnabled"][acsProfiler][indexer];
			acsPvEHealthPotionBuff[indexer]=acs[acsPlayerName][acsClass]["HealthPotionBuff"][acsProfiler][indexer];
			acsPvEHealthPotionPercent[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealthPotionPercent"][acsProfiler][indexer]);
			acsPvEHealthPotionOutEnabled[indexer]=acs[acsPlayerName][acsClass]["HealthPotionOutEnabled"][acsProfiler][indexer];
		end

		acsPvPSkillSlot={};
		acsPvPSkillEnabled={};
		acsPvPSkillCheck1={};
		acsPvPSkillExist1={};
		acsPvPSkillCheck2={};
		acsPvPSkillExist2={};
		acsPvPSkillHP={};
		acsPvPSkillPercentHP={};
		acsPvPSkillMP={};
		acsPvPSkillPercentMP={};
		acsPvPSkillStopMove={};
		
		acsPvPAttackEnabled=acs[acsPlayerName][acsClass]["AttackEnabled"][3];
		acsPvPAttackSlot=tonumber(acs[acsPlayerName][acsClass]["AttackSlot"][3]);
		
		for indexer = 1,20 do
			acsPvPSkillSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["SkillSlot"][3][indexer]);
			acsPvPSkillEnabled[indexer]=acs[acsPlayerName][acsClass]["SkillEnabled"][3][indexer];
			acsPvPSkillCheck1[indexer]=acs[acsPlayerName][acsClass]["SkillCheck1"][3][indexer];
			acsPvPSkillExist1[indexer]=acs[acsPlayerName][acsClass]["SkillExist1"][3][indexer];
			acsPvPSkillCheck2[indexer]=acs[acsPlayerName][acsClass]["SkillExist2"][3][indexer];
			acsPvPSkillExist2[indexer]=acs[acsPlayerName][acsClass]["SkillExist2"][3][indexer];
			acsPvPSkillHP[indexer]=acs[acsPlayerName][acsClass]["SkillHP"][3][indexer];
			acsPvPSkillPercentHP[indexer]=acs[acsPlayerName][acsClass]["SkillPercentHP"][3][indexer];
			acsPvPSkillMP[indexer]=acs[acsPlayerName][acsClass]["SkillMP"][3][indexer];
			acsPvPSkillPercentMP[indexer]=acs[acsPlayerName][acsClass]["SkillPercentMP"][3][indexer];
			acsPvPSkillStopMove[indexer]=acs[acsPlayerName][acsClass]["SkillStopMove"][3][indexer];
		end

		acsBuffPvPSlot={};
		acsBuffPvPEnabled={};
		acsBuffPvPName={};
		acsBuffPvPCombat={};
		acsBuffPvPCombatOnly={};
		
		for indexer = 1,20 do
			acsBuffPvPSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["BuffSlot"][3][indexer]);
			acsBuffPvPEnabled[indexer]=acs[acsPlayerName][acsClass]["BuffEnabled"][3][indexer];
			acsBuffPvPName[indexer]=acs[acsPlayerName][acsClass]["BuffName"][3][indexer];
			acsBuffPvPCombat[indexer]=acs[acsPlayerName][acsClass]["BuffCombat"][3][indexer];
			acsBuffPvPCombatOnly[indexer]=acs[acsPlayerName][acsClass]["BuffCombatOnly"][3][indexer];
		end

		acsHealPvPSlot={};
		acsHealPvPEnabled={};
		acsHealPvPBuff={};
		acsHealPvPPercent={};
		
		for indexer = 1,20 do
			acsHealPvPSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealSlot"][3][indexer]);
			acsHealPvPEnabled[indexer]=acs[acsPlayerName][acsClass]["HealEnabled"][3][indexer];
			acsHealPvPBuff[indexer]=acs[acsPlayerName][acsClass]["HealBuff"][3][indexer];
			acsHealPvPPercent[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealPercent"][3][indexer]);
		end

		acsHealthPvPPotionSlot={};
		acsHealthPvPPotionEnabled={};
		acsHealthPvPPotionBuff={};
		acsHealthPvPPotionPercent={};
		
		for indexer = 1,4 do
			acsHealthPvPPotionSlot[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealthPotionSlot"][3][indexer]);
			acsHealthPvPPotionEnabled[indexer]=acs[acsPlayerName][acsClass]["HealthPotionEnabled"][3][indexer];
			acsHealthPvPPotionBuff[indexer]=acs[acsPlayerName][acsClass]["HealthPotionBuff"][3][indexer];
			acsHealthPvPPotionPercent[indexer]=tonumber(acs[acsPlayerName][acsClass]["HealthPotionPercent"][3][indexer]);
		end

		ACS_Vars_Loaded=true;
		
	else
		acsConfRunnerFrame_VARIABLES_LOAD();
	end

end


function acsConfRunnerFrame_VARIABLES_LOAD()

	if ( ( not acsPlayerName ) or acsPlayerName~=UnitName("player") ) then
		if ( UnitName("player") ) then
			acsPlayerName=UnitName("player");
		else
			return;
		end
	end

	if ( ( not acsClass ) or acsClass~=UnitClass("player") ) then
		if ( UnitClass("player") ) then
			acsClass, acsClass2=UnitClass("player");
		else
			return;
		end
	end
	
	if ( acs==nil ) then
		acs={};
	end
	
	if ( acs[acsPlayerName]==nil ) then
		acs[acsPlayerName]={};
	end

	if ( acs[acsPlayerName][acsClass]==nil ) then
		acs[acsPlayerName][acsClass]={};
		acs[acsPlayerName][acsClass]["IconShow"]=true;
		acs[acsPlayerName][acsClass]["OneSwitch"]=false;
		acs[acsPlayerName][acsClass]["Manual"]=false;
		acs[acsPlayerName][acsClass]["ProfileSelected"]=1;
		acs[acsPlayerName][acsClass]["InOrderCast"]=false;
		acs[acsPlayerName][acsClass]["PriorityCast"]=true;
		acs[acsPlayerName][acsClass]["TickRate"]=0.1;
		acs[acsPlayerName][acsClass]["AttackEnabled"]={};
		acs[acsPlayerName][acsClass]["AttackSlot"]={};
		acs[acsPlayerName][acsClass]["Loot"]={};
		acs[acsPlayerName][acsClass]["SliderSetting"]={};
		acs[acsPlayerName][acsClass]["SkillEnabled"]={};
		acs[acsPlayerName][acsClass]["SkillSlot"]={};
		acs[acsPlayerName][acsClass]["SkillCheck1"]={};
		acs[acsPlayerName][acsClass]["SkillCheck2"]={};
		acs[acsPlayerName][acsClass]["SkillExist1"]={};
		acs[acsPlayerName][acsClass]["SkillExist2"]={};
		acs[acsPlayerName][acsClass]["SkillHP"]={};
		acs[acsPlayerName][acsClass]["SkillPercentHP"]={};
		acs[acsPlayerName][acsClass]["SkillMP"]={};
		acs[acsPlayerName][acsClass]["SkillPercentMP"]={};
		acs[acsPlayerName][acsClass]["SkillName"]={};
		acs[acsPlayerName][acsClass]["SkillOrder"]={};
		acs[acsPlayerName][acsClass]["SkillStopMove"]={};
		acs[acsPlayerName][acsClass]["BuffOthers"]={};
		acs[acsPlayerName][acsClass]["BuffSliderSetting"]={};
		acs[acsPlayerName][acsClass]["BuffEnabled"]={};
		acs[acsPlayerName][acsClass]["BuffSlot"]={};
		acs[acsPlayerName][acsClass]["BuffName"]={};
		acs[acsPlayerName][acsClass]["BuffCombat"]={};
		acs[acsPlayerName][acsClass]["BuffCombatOnly"]={};
		acs[acsPlayerName][acsClass]["HealSliderSetting"]={};
		acs[acsPlayerName][acsClass]["HealEnabled"]={};
		acs[acsPlayerName][acsClass]["HealSlot"]={};
		acs[acsPlayerName][acsClass]["HealBuff"]={};
		acs[acsPlayerName][acsClass]["HealPercent"]={};
		acs[acsPlayerName][acsClass]["HealOthers"]={};
		acs[acsPlayerName][acsClass]["HealthPotionOutEnabled"]={};
		acs[acsPlayerName][acsClass]["HealthPotionEnabled"]={};
		acs[acsPlayerName][acsClass]["HealthPotionSlot"]={};
		acs[acsPlayerName][acsClass]["HealthPotionBuff"]={};
		acs[acsPlayerName][acsClass]["HealthPotionPercent"]={};

		for i = 1,3 do
			acs[acsPlayerName][acsClass]["AttackEnabled"][i]=false;
			acs[acsPlayerName][acsClass]["AttackSlot"][i]=0;
			
			acs[acsPlayerName][acsClass]["Loot"][i]=false;
			
			acs[acsPlayerName][acsClass]["SliderSetting"][i]=10;
			acs[acsPlayerName][acsClass]["SkillEnabled"][i]={};
			acs[acsPlayerName][acsClass]["SkillSlot"][i]={};
			acs[acsPlayerName][acsClass]["SkillCheck1"][i]={};
			acs[acsPlayerName][acsClass]["SkillCheck2"][i]={};
			acs[acsPlayerName][acsClass]["SkillExist1"][i]={};
			acs[acsPlayerName][acsClass]["SkillExist2"][i]={};
			acs[acsPlayerName][acsClass]["SkillHP"][i]={};
			acs[acsPlayerName][acsClass]["SkillPercentHP"][i]={};
			acs[acsPlayerName][acsClass]["SkillMP"][i]={};
			acs[acsPlayerName][acsClass]["SkillPercentMP"][i]={};
			acs[acsPlayerName][acsClass]["SkillName"][i]={};
			acs[acsPlayerName][acsClass]["SkillOrder"][i]={};
			acs[acsPlayerName][acsClass]["SkillStopMove"][i]={};
			
			for indexer = 1,20 do
				acs[acsPlayerName][acsClass]["SkillEnabled"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["SkillSlot"][i][indexer]=0;
				acs[acsPlayerName][acsClass]["SkillCheck1"][i][indexer]="<De/Buff>";
				acs[acsPlayerName][acsClass]["SkillCheck2"][i][indexer]="<De/Buff>";
				acs[acsPlayerName][acsClass]["SkillExist1"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["SkillExist2"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["SkillHP"][i][indexer]=0;
				acs[acsPlayerName][acsClass]["SkillPercentHP"][i][indexer]=true;
				acs[acsPlayerName][acsClass]["SkillMP"][i][indexer]=0;
				acs[acsPlayerName][acsClass]["SkillPercentMP"][i][indexer]=true;
				acs[acsPlayerName][acsClass]["SkillName"][i][indexer]="<Spell>";
				acs[acsPlayerName][acsClass]["SkillOrder"][i][indexer]=indexer;
				acs[acsPlayerName][acsClass]["SkillStopMove"][i][indexer]=false;
			end
			
			acs[acsPlayerName][acsClass]["BuffSliderSetting"][i]=10;
			acs[acsPlayerName][acsClass]["BuffEnabled"][i]={};
			acs[acsPlayerName][acsClass]["BuffSlot"][i]={};
			acs[acsPlayerName][acsClass]["BuffName"][i]={};
			acs[acsPlayerName][acsClass]["BuffCombat"][i]={};
			acs[acsPlayerName][acsClass]["BuffCombatOnly"][i]={};
			acs[acsPlayerName][acsClass]["BuffOthers"][i]={};
		
			for indexer = 1,20 do
				acs[acsPlayerName][acsClass]["BuffEnabled"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["BuffSlot"][i][indexer]=0;
				acs[acsPlayerName][acsClass]["BuffName"][i][indexer]="<Buff>";
				acs[acsPlayerName][acsClass]["BuffCombat"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["BuffCombatOnly"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["BuffOthers"][i][indexer]=false;
			end

			acs[acsPlayerName][acsClass]["HealSliderSetting"][i]=10;
			acs[acsPlayerName][acsClass]["HealEnabled"][i]={};
			acs[acsPlayerName][acsClass]["HealSlot"][i]={};
			acs[acsPlayerName][acsClass]["HealBuff"][i]={};
			acs[acsPlayerName][acsClass]["HealPercent"][i]={};
			acs[acsPlayerName][acsClass]["HealOthers"][i]={};
		
			for indexer = 1,20 do
				acs[acsPlayerName][acsClass]["HealEnabled"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["HealSlot"][i][indexer]=0;
				acs[acsPlayerName][acsClass]["HealBuff"][i][indexer]="<Heal Buff>";
				acs[acsPlayerName][acsClass]["HealPercent"][i][indexer]=50;
				acs[acsPlayerName][acsClass]["HealOthers"][i][indexer]=false;
			end

			acs[acsPlayerName][acsClass]["HealthPotionEnabled"][i]={};
			acs[acsPlayerName][acsClass]["HealthPotionSlot"][i]={};
			acs[acsPlayerName][acsClass]["HealthPotionBuff"][i]={};
			acs[acsPlayerName][acsClass]["HealthPotionPercent"][i]={};
			acs[acsPlayerName][acsClass]["HealthPotionOutEnabled"][i]={};
			
			for indexer = 1,4 do
				acs[acsPlayerName][acsClass]["HealthPotionEnabled"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["HealthPotionSlot"][i][indexer]=0;
				acs[acsPlayerName][acsClass]["HealthPotionBuff"][i][indexer]="<Potion Buff>";
				acs[acsPlayerName][acsClass]["HealthPotionPercent"][i][indexer]=50;
				acs[acsPlayerName][acsClass]["HealthPotionOutEnabled"][i][indexer]=false;
			end
		end
		
		acs[acsPlayerName][acsClass]["VarsVersion"]=3;
		
	else
		acsConfVariablesLoaded=true;
	end


	if ( acs[acsPlayerName][acsClass]["VarsVersion"]==1 ) then
		acs[acsPlayerName][acsClass]["SkillCheck1"]={};
		acs[acsPlayerName][acsClass]["SkillCheck2"]={};
		acs[acsPlayerName][acsClass]["SkillExist1"]={};
		acs[acsPlayerName][acsClass]["SkillExist2"]={};
		acs[acsPlayerName][acsClass]["SkillHP"]={};
		acs[acsPlayerName][acsClass]["SkillPercentHP"]={};
		acs[acsPlayerName][acsClass]["SkillMP"]={};
		acs[acsPlayerName][acsClass]["SkillPercentMP"]={};
		acs[acsPlayerName][acsClass]["SkillName"]={};
		acs[acsPlayerName][acsClass]["SkillOrder"]={};
		
		for i = 1,3 do
			acs[acsPlayerName][acsClass]["SkillCheck1"][i]={};
			acs[acsPlayerName][acsClass]["SkillCheck2"][i]={};
			acs[acsPlayerName][acsClass]["SkillExist1"][i]={};
			acs[acsPlayerName][acsClass]["SkillExist2"][i]={};
			acs[acsPlayerName][acsClass]["SkillHP"][i]={};
			acs[acsPlayerName][acsClass]["SkillPercentHP"][i]={};
			acs[acsPlayerName][acsClass]["SkillMP"][i]={};
			acs[acsPlayerName][acsClass]["SkillPercentMP"][i]={};
			acs[acsPlayerName][acsClass]["SkillName"][i]={};
			acs[acsPlayerName][acsClass]["SkillOrder"][i]={};
			
			for indexer = 1,20 do
				if ( not ( acs[acsPlayerName][acsClass]["SkillDebuff"][i][indexer]=="<Debuff>" ) ) then
					acs[acsPlayerName][acsClass]["SkillCheck1"][i][indexer] = acs[acsPlayerName][acsClass]["SkillDebuff"][i][indexer];
				else
					acs[acsPlayerName][acsClass]["SkillCheck1"][i][indexer]="<De/Buff>";
				end
				
				acs[acsPlayerName][acsClass]["SkillExist1"][i][indexer] = acs[acsPlayerName][acsClass]["SkillDebuffExist"][i][indexer];
				acs[acsPlayerName][acsClass]["SkillHP"][i][indexer] = acs[acsPlayerName][acsClass]["SkillDebuffCount"][i][indexer];
				
				acs[acsPlayerName][acsClass]["SkillDebuff"][i][indexer]=nil;
				acs[acsPlayerName][acsClass]["SkillDebuffExist"][i][indexer]=nil;
				acs[acsPlayerName][acsClass]["SkillDebuffCount"][i][indexer]=nil;
				
				acs[acsPlayerName][acsClass]["SkillCheck2"][i][indexer]="<De/Buff>";
				acs[acsPlayerName][acsClass]["SkillExist2"][i][indexer]=false;
				acs[acsPlayerName][acsClass]["SkillPercentHP"][i][indexer]=true;
				acs[acsPlayerName][acsClass]["SkillMP"][i][indexer]=0;
				acs[acsPlayerName][acsClass]["SkillPercentMP"][i][indexer]=true;
				acs[acsPlayerName][acsClass]["SkillName"][i][indexer]="<Spell>";
				acs[acsPlayerName][acsClass]["SkillOrder"][i][indexer]=indexer;
			end
		end
		
		acs[acsPlayerName][acsClass]["VarsVersion"]=2;
	end

	if ( acs[acsPlayerName][acsClass]["VarsVersion"]==2 ) then
		acs[acsPlayerName][acsClass]["SkillStopMove"]={};
		acs[acsPlayerName][acsClass]["Loot"]={};
		
		for i = 1,3 do
			acs[acsPlayerName][acsClass]["SkillStopMove"][i]={};
			acs[acsPlayerName][acsClass]["Loot"][i]=false;
			
			for indexer = 1,20 do
				acs[acsPlayerName][acsClass]["SkillStopMove"][i][indexer]=false;
			end
		end
		
		acs[acsPlayerName][acsClass]["VarsVersion"]=3;
	end

	acsProfileSelected = tonumber( acs[acsPlayerName][acsClass]["ProfileSelected"] );

	acsConfPanelFrame2Edit00_1:SetText(acs[acsPlayerName][acsClass]["TickRate"]);

	acsConfPanelFrameSpellsCheckButton00000_1:SetChecked(acs[acsPlayerName][acsClass]["IconShow"]);

	acsConfPanelFrameSpellsCheckButton000000_1:SetChecked(acs[acsPlayerName][acsClass]["OneSwitch"]);
	acsConfPanelFrameSpellsCheckButton0000000_1:SetChecked(acs[acsPlayerName][acsClass]["Manual"]);

	acsConfPanelFrameSpellsCheckButton00_1:SetChecked(acs[acsPlayerName][acsClass]["InOrderCast"]);
	acsConfPanelFrameSpellsCheckButton000_1:SetChecked(acs[acsPlayerName][acsClass]["PriorityCast"]);


	
--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING Profile SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]

	acsConfPanelFrameSpellsSlider:SetValue(acs[acsPlayerName][acsClass]["SliderSetting"][acsProfileSelected]);

	for i=1,20 do
		getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_1"):SetChecked(acs[acsPlayerName][acsClass]["SkillEnabled"][acsProfileSelected][i]);
		
		if (  acs[acsPlayerName][acsClass]["SkillSlot"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["SkillSlot"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_7"):SetText("0");
		else
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_7"):SetText(acs[acsPlayerName][acsClass]["SkillSlot"][acsProfileSelected][i]);
		end
		
		if ( ( not acs[acsPlayerName][acsClass]["SkillCheck1"][acsProfileSelected][i] ) or acs[acsPlayerName][acsClass]["SkillCheck1"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_3"):SetText("<De/Buff>");
		else
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_3"):SetText(acs[acsPlayerName][acsClass]["SkillCheck1"][acsProfileSelected][i]);
		end
		
		getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_2"):SetChecked(acs[acsPlayerName][acsClass]["SkillExist1"][acsProfileSelected][i]);
		
		getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_3"):SetChecked(acs[acsPlayerName][acsClass]["SkillExist2"][acsProfileSelected][i]);
		
		if (  acs[acsPlayerName][acsClass]["SkillHP"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["SkillHP"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_5"):SetText("0");
		else
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_5"):SetText(acs[acsPlayerName][acsClass]["SkillHP"][acsProfileSelected][i]);
		end
		
		if ( ( not acs[acsPlayerName][acsClass]["SkillName"][acsProfileSelected][i] ) or acs[acsPlayerName][acsClass]["SkillName"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_1"):SetText("<Spell>");
		else
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_1"):SetText(acs[acsPlayerName][acsClass]["SkillName"][acsProfileSelected][i]);
		end
		
		if (  acs[acsPlayerName][acsClass]["SkillOrder"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["SkillOrder"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_2"):SetText(i);
		else
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_2"):SetText(acs[acsPlayerName][acsClass]["SkillOrder"][acsProfileSelected][i]);
		end
		
		if ( ( not acs[acsPlayerName][acsClass]["SkillCheck2"][acsProfileSelected][i] ) or acs[acsPlayerName][acsClass]["SkillCheck2"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_4"):SetText("<De/Buff>");
		else
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_4"):SetText(acs[acsPlayerName][acsClass]["SkillCheck2"][acsProfileSelected][i]);
		end
		
		if (  acs[acsPlayerName][acsClass]["SkillMP"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["SkillMP"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_6"):SetText("0");
		else
			getglobal("acsConfPanelFrameSpellsEdit"..i.."_6"):SetText(acs[acsPlayerName][acsClass]["SkillMP"][acsProfileSelected][i]);
		end
		
		getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_4"):SetChecked(acs[acsPlayerName][acsClass]["SkillPercentHP"][acsProfileSelected][i]);
		
		getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_5"):SetChecked(acs[acsPlayerName][acsClass]["SkillPercentMP"][acsProfileSelected][i]);
		
		getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_6"):SetChecked(acs[acsPlayerName][acsClass]["SkillStopMove"][acsProfileSelected][i]);
	end

	acsConfPanelFrameSpellsCheckButton0_1:SetChecked(acs[acsPlayerName][acsClass]["AttackEnabled"][acsProfileSelected]);
	acsConfPanelFrameSpellsEdit0_1:SetText(acs[acsPlayerName][acsClass]["AttackSlot"][acsProfileSelected]);
	
	acsConfPanelFrameSpellsCheckButton0_2:SetChecked(acs[acsPlayerName][acsClass]["Loot"][acsProfileSelected]);

--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING BUFFS SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]
	
	acsConfPanelFrameBuffsSlider:SetValue(acs[acsPlayerName][acsClass]["BuffSliderSetting"][acsProfileSelected]);

	for i=1,20 do
		getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_1"):SetChecked(acs[acsPlayerName][acsClass]["BuffEnabled"][acsProfileSelected][i]);
		
		if ( acs[acsPlayerName][acsClass]["BuffSlot"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["BuffSlot"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameBuffsEdit"..i.."_1"):SetText("0");
		else
			getglobal("acsConfPanelFrameBuffsEdit"..i.."_1"):SetText(acs[acsPlayerName][acsClass]["BuffSlot"][acsProfileSelected][i]);
		end
		
		if ( ( not acs[acsPlayerName][acsClass]["BuffName"][acsProfileSelected][i] ) or acs[acsPlayerName][acsClass]["BuffName"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameBuffsEdit"..i.."_2"):SetText("<Buff>");
		else
			getglobal("acsConfPanelFrameBuffsEdit"..i.."_2"):SetText(acs[acsPlayerName][acsClass]["BuffName"][acsProfileSelected][i]);
		end
		
		getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_2"):SetChecked(acs[acsPlayerName][acsClass]["BuffCombat"][acsProfileSelected][i]);
		
		getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_3"):SetChecked(acs[acsPlayerName][acsClass]["BuffCombatOnly"][acsProfileSelected][i]);
		
		getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_4"):SetChecked(acs[acsPlayerName][acsClass]["BuffOthers"][acsProfileSelected][i]);
	end


--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING HEALS SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]
	

	acsConfPanelFrameHealsSlider:SetValue(acs[acsPlayerName][acsClass]["HealSliderSetting"][acsProfileSelected]);

	for i=1,20 do
		getglobal("acsConfPanelFrameHealsCheckButton"..i.."_1"):SetChecked(acs[acsPlayerName][acsClass]["HealEnabled"][acsProfileSelected][i]);

		if ( acs[acsPlayerName][acsClass]["HealSlot"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["HealSlot"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameHealsEdit"..i.."_1"):SetText("0");
		else
			getglobal("acsConfPanelFrameHealsEdit"..i.."_1"):SetText(acs[acsPlayerName][acsClass]["HealSlot"][acsProfileSelected][i]);
		end

		if ( ( not acs[acsPlayerName][acsClass]["HealBuff"][acsProfileSelected][i] ) or acs[acsPlayerName][acsClass]["HealBuff"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameHealsEdit"..i.."_2"):SetText("<Buff>");
		else
			getglobal("acsConfPanelFrameHealsEdit"..i.."_2"):SetText(acs[acsPlayerName][acsClass]["HealBuff"][acsProfileSelected][i]);
		end

		if ( acs[acsPlayerName][acsClass]["HealPercent"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["HealPercent"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameHealsEdit"..i.."_3"):SetText("0");
		else
			getglobal("acsConfPanelFrameHealsEdit"..i.."_3"):SetText(acs[acsPlayerName][acsClass]["HealPercent"][acsProfileSelected][i]);
		end
		
		getglobal("acsConfPanelFrameHealsCheckButton"..i.."_2"):SetChecked(acs[acsPlayerName][acsClass]["HealOthers"][acsProfileSelected][i]);
	end


--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING HEALTH POTIONS SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]
	

	for i=1,4 do
		getglobal("acsConfPanelFrameHealthPotionsCheckButton"..i.."_1"):SetChecked(acs[acsPlayerName][acsClass]["HealthPotionEnabled"][acsProfileSelected][i]);
		
		if ( acs[acsPlayerName][acsClass]["HealthPotionSlot"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["HealthPotionSlot"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_1"):SetText("0");
		else
			getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_1"):SetText(acs[acsPlayerName][acsClass]["HealthPotionSlot"][acsProfileSelected][i]);
		end
		
		if ( ( not acs[acsPlayerName][acsClass]["HealthPotionBuff"][acsProfileSelected][i] ) or acs[acsPlayerName][acsClass]["HealthPotionBuff"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_2"):SetText("<Buff>");
		else
			getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_2"):SetText(acs[acsPlayerName][acsClass]["HealthPotionBuff"][acsProfileSelected][i]);
		end
		
		if ( acs[acsPlayerName][acsClass]["HealthPotionPercent"][acsProfileSelected][i]==nil or acs[acsPlayerName][acsClass]["HealthPotionPercent"][acsProfileSelected][i]=="" ) then
			getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_3"):SetText("0");
		else
			getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_3"):SetText(acs[acsPlayerName][acsClass]["HealthPotionPercent"][acsProfileSelected][i]);
		end
		
		getglobal("acsConfPanelFrameHealthPotionsCheckButton"..i.."_2"):SetChecked(acs[acsPlayerName][acsClass]["HealthPotionOutEnabled"][acsProfileSelected][i]);
	end



	acsVariables()

end


function ConfigFrameOption_OnClick()

	acs[acsPlayerName][acsClass]["TickRate"] = acsConfPanelFrame2Edit00_1:GetText();

	acs[acsPlayerName][acsClass]["IconShow"] = acsConfPanelFrameSpellsCheckButton00000_1:IsChecked();
	
	if ( acs["IconShow"]==false and SimpleTimer3:IsVisible() ) then
		SimpleTimer3:Hide();
	elseif ( not SimpleTimer3:IsVisible() ) then
		SimpleTimer3:Show();
	end

	acs[acsPlayerName][acsClass]["OneSwitch"] = acsConfPanelFrameSpellsCheckButton000000_1:IsChecked();
	acs[acsPlayerName][acsClass]["Manual"] = acsConfPanelFrameSpellsCheckButton0000000_1:IsChecked();

	acs[acsPlayerName][acsClass]["InOrderCast"] = acsConfPanelFrameSpellsCheckButton00_1:IsChecked();
	acs[acsPlayerName][acsClass]["PriorityCast"] = acsConfPanelFrameSpellsCheckButton000_1:IsChecked();

--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING Profile SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]

	acs[acsPlayerName][acsClass]["SliderSetting"][acsProfileSelected]=acsConfPanelFrameSpellsSlider:GetValue();

	for i=1,20 do
		if ( ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_2"):GetText() )==nil or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_2"):GetText() )=="" or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_2"):GetText() )=="0" ) then
			acsOrderingCounter = i;
			acs[acsPlayerName][acsClass]["SkillOrder"][acsProfileSelected][i] = i;
		else
			acsOrderingCounter = tonumber( getglobal("acsConfPanelFrameSpellsEdit"..i.."_2"):GetText() );
			acs[acsPlayerName][acsClass]["SkillOrder"][acsProfileSelected][acsOrderingCounter] = acsOrderingCounter;
		end
		
		acs[acsPlayerName][acsClass]["SkillEnabled"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_1"):IsChecked();
		
		if ( ( ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_7"):GetText() )==nil ) or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_7"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["SkillSlot"][acsProfileSelected][acsOrderingCounter] = "0";
		else
			acs[acsPlayerName][acsClass]["SkillSlot"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsEdit"..i.."_7"):GetText();
		end
		
		if ( ( not ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_3"):GetText() ) ) or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_3"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["SkillCheck1"][acsProfileSelected][acsOrderingCounter]="<De/Buff>";
		else
			acs[acsPlayerName][acsClass]["SkillCheck1"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsEdit"..i.."_3"):GetText();
		end
		
		acs[acsPlayerName][acsClass]["SkillExist1"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_2"):IsChecked();
		
		acs[acsPlayerName][acsClass]["SkillExist2"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_3"):IsChecked();

		if ( ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_5"):GetText() )==nil or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_5"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["SkillHP"][acsProfileSelected][acsOrderingCounter] = "0";
		else
			acs[acsPlayerName][acsClass]["SkillHP"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsEdit"..i.."_5"):GetText();
		end
		
		if ( ( not ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_1"):GetText() ) ) or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_1"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["SkillName"][acsProfileSelected][acsOrderingCounter]="<Spell>";
		else
			acs[acsPlayerName][acsClass]["SkillName"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsEdit"..i.."_1"):GetText();
		end
		
		if ( ( not ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_4"):GetText() ) ) or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_4"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["SkillCheck2"][acsProfileSelected][acsOrderingCounter]="<De/Buff>";
		else
			acs[acsPlayerName][acsClass]["SkillCheck2"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsEdit"..i.."_4"):GetText();
		end
		
		if ( ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_6"):GetText() )==nil or ( getglobal("acsConfPanelFrameSpellsEdit"..i.."_6"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["SkillMP"][acsProfileSelected][acsOrderingCounter] = "0";
		else
			acs[acsPlayerName][acsClass]["SkillMP"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsEdit"..i.."_6"):GetText();
		end
		
		acs[acsPlayerName][acsClass]["SkillPercentHP"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_4"):IsChecked();
		
		acs[acsPlayerName][acsClass]["SkillPercentMP"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_5"):IsChecked();
		
		acs[acsPlayerName][acsClass]["SkillStopMove"][acsProfileSelected][acsOrderingCounter] = getglobal("acsConfPanelFrameSpellsCheckButton"..i.."_6"):IsChecked();
	end

	acs[acsPlayerName][acsClass]["AttackEnabled"][acsProfileSelected] = acsConfPanelFrameSpellsCheckButton0_1:IsChecked();
	acs[acsPlayerName][acsClass]["AttackSlot"][acsProfileSelected] = acsConfPanelFrameSpellsEdit0_1:GetText();
	
	acs[acsPlayerName][acsClass]["Loot"][acsProfileSelected] = acsConfPanelFrameSpellsCheckButton0_2:IsChecked();


--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING BUFFS SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]
	acs[acsPlayerName][acsClass]["BuffSliderSetting"][acsProfileSelected]=acsConfPanelFrameBuffsSlider:GetValue();

	for i=1,20 do
		acs[acsPlayerName][acsClass]["BuffEnabled"][acsProfileSelected][i] = getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_1"):IsChecked();
		
		if ( ( ( getglobal("acsConfPanelFrameBuffsEdit"..i.."_1"):GetText() )==nil ) or ( getglobal("acsConfPanelFrameBuffsEdit"..i.."_1"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["BuffSlot"][acsProfileSelected][i] = "0";
		else
			acs[acsPlayerName][acsClass]["BuffSlot"][acsProfileSelected][i] = getglobal("acsConfPanelFrameBuffsEdit"..i.."_1"):GetText();
		end
		
		if ( ( not ( getglobal("acsConfPanelFrameBuffsEdit"..i.."_2"):GetText() ) ) or ( getglobal("acsConfPanelFrameBuffsEdit"..i.."_2"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["BuffName"][acsProfileSelected][i]="<Buff>";
		else
			acs[acsPlayerName][acsClass]["BuffName"][acsProfileSelected][i] = getglobal("acsConfPanelFrameBuffsEdit"..i.."_2"):GetText();
		end
		
		acs[acsPlayerName][acsClass]["BuffCombat"][acsProfileSelected][i] = getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_2"):IsChecked();
		acs[acsPlayerName][acsClass]["BuffCombatOnly"][acsProfileSelected][i] = getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_3"):IsChecked();
		acs[acsPlayerName][acsClass]["BuffOthers"][acsProfileSelected][i] = getglobal("acsConfPanelFrameBuffsCheckButton"..i.."_4"):IsChecked();
		
	end

--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING HEALS SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]
	

	acs[acsPlayerName][acsClass]["HealSliderSetting"][acsProfileSelected]=acsConfPanelFrameHealsSlider:GetValue();

	for i=1,20 do
		acs[acsPlayerName][acsClass]["HealEnabled"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealsCheckButton"..i.."_1"):IsChecked();
		
		if ( ( ( getglobal("acsConfPanelFrameHealsEdit"..i.."_1"):GetText() )==nil ) or ( getglobal("acsConfPanelFrameHealsEdit"..i.."_1"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["HealSlot"][acsProfileSelected][i] = "0";
		else
			acs[acsPlayerName][acsClass]["HealSlot"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealsEdit"..i.."_1"):GetText();
		end
		
		if ( ( not ( getglobal("acsConfPanelFrameHealsEdit"..i.."_2"):GetText() ) ) or ( getglobal("acsConfPanelFrameHealsEdit"..i.."_2"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["HealBuff"][acsProfileSelected][i]="<Heal Buff>";
		else
			acs[acsPlayerName][acsClass]["HealBuff"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealsEdit"..i.."_2"):GetText();
		end
		
		if ( ( ( getglobal("acsConfPanelFrameHealsEdit"..i.."_3"):GetText() )==nil ) or ( getglobal("acsConfPanelFrameHealsEdit"..i.."_3"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["HealPercent"][acsProfileSelected][i] = "50";
		else
			acs[acsPlayerName][acsClass]["HealPercent"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealsEdit"..i.."_3"):GetText();
		end
		
		acs[acsPlayerName][acsClass]["HealOthers"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealsCheckButton"..i.."_2"):IsChecked();
	end

--[[
	
	
	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> STARTING HEALTH POTIONS SETTINGS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	
--]]
	

	for i=1,4 do
		acs[acsPlayerName][acsClass]["HealthPotionEnabled"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealthPotionsCheckButton"..i.."_1"):IsChecked();
		
		if ( ( ( getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_1"):GetText() )==nil ) or ( getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_1"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["HealthPotionSlot"][acsProfileSelected][i] = "0";
		else
			acs[acsPlayerName][acsClass]["HealthPotionSlot"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_1"):GetText();
		end
		
		if ( ( not ( getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_2"):GetText() ) ) or ( getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_2"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["HealthPotionBuff"][acsProfileSelected][i]="<Potion Buff>";
		else
			acs[acsPlayerName][acsClass]["HealthPotionBuff"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_2"):GetText();
		end
		
		if ( ( ( getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_3"):GetText() )==nil ) or ( getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_3"):GetText() )=="" ) then
			acs[acsPlayerName][acsClass]["HealthPotionPercent"][acsProfileSelected][i] = "50";
		else
			acs[acsPlayerName][acsClass]["HealthPotionPercent"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealthPotionsEdit"..i.."_3"):GetText();
		end
		
		acs[acsPlayerName][acsClass]["HealthPotionOutEnabled"][acsProfileSelected][i] = getglobal("acsConfPanelFrameHealthPotionsCheckButton"..i.."_2"):IsChecked();
	end

	
	acsCleanUpVars();
	
	acsVariables();

end


function acsUpdateMainframe()

	if ( acsConfPanelFrameSpells:IsVisible() ) then
		acsConfPanelFrame2:SetHeight( ( (acsConfPanelFrameSpellsSlider:GetValue())*27 )+165 );
		acsConfPanelFrameSpells:SetHeight( ( (acsConfPanelFrameSpellsSlider:GetValue())*27 )+140 );
		acsConfPanelFrameSpells:SetWidth ( 702 );
		acsConfPanelFrame2:SetWidth ( 702 );
		acsConfPanelFrameSpellsCheckButton0_1:ClearAllAnchors();
		acsConfPanelFrameSpellsCheckButton0_1:SetAnchor("TOPLEFT", "TOPLEFT", "acsConfPanelFrameSpellsCheckButton1_1", 0, ( ( ( ( acsConfPanelFrameSpellsSlider:GetValue() )-3 )*27 )+80 ) );	
		acsConfPanelFrame2Edit00_1:ClearAllAnchors();
		acsConfPanelFrame2Edit00_1:SetAnchor("BOTTOMLEFT", "BOTTOMLEFT", "acsConfPanelFrame2", 80, -40 );	
	end
	
	if ( acsConfPanelFrameHeals:IsVisible() ) then
		acsConfPanelFrame2:SetHeight( ( (acsConfPanelFrameHealsSlider:GetValue())*27 )+113 );
		acsConfPanelFrameHeals:SetHeight( ( (acsConfPanelFrameHealsSlider:GetValue())*27 )+88 );
		acsConfPanelFrameHeals:SetWidth ( 527 );
		acsConfPanelFrame2:SetWidth ( 527 );
		acsConfPanelFrame2Edit00_1:ClearAllAnchors();
		acsConfPanelFrame2Edit00_1:SetAnchor("BOTTOMLEFT", "BOTTOMLEFT", "acsConfPanelFrame2", 80, -40 );	
	end

	if ( acsConfPanelFrameBuffs:IsVisible() ) then
		acsConfPanelFrame2:SetHeight( ( (acsConfPanelFrameBuffsSlider:GetValue())*27 )+113 );
		acsConfPanelFrameBuffs:SetHeight( ( (acsConfPanelFrameBuffsSlider:GetValue())*27 )+88 );
		acsConfPanelFrameBuffs:SetWidth ( 630 );
		acsConfPanelFrame2:SetWidth ( 630 );
		acsConfPanelFrame2Edit00_1:ClearAllAnchors();
		acsConfPanelFrame2Edit00_1:SetAnchor("BOTTOMLEFT", "BOTTOMLEFT", "acsConfPanelFrame2", 80, -40 );	
	end

	if ( acsConfPanelFrameHealthPotions:IsVisible() ) then
		acsConfPanelFrame2:SetHeight( 215 );
		acsConfPanelFrameHealthPotions:SetHeight( 185 );
		acsConfPanelFrameHealthPotions:SetWidth ( 575 );
		acsConfPanelFrame2:SetWidth ( 575 );
		acsConfPanelFrame2Edit00_1:ClearAllAnchors();
		acsConfPanelFrame2Edit00_1:SetAnchor("BOTTOMLEFT", "BOTTOMLEFT", "acsConfPanelFrame2", 80, -15 );	
	end

	for i=1,19 do
		if ( ( acsConfPanelFrameSpellsSlider:GetValue() )<=( 20-i ) ) then
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_3"):Hide();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_4"):Hide();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_3"):Hide();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_5"):Hide();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_4"):Hide();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_6"):Hide();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_5"):Hide();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_7"):Hide();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_6"):Hide();
		else
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_3"):Show();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_4"):Show();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_3"):Show();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_5"):Show();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_4"):Show();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_6"):Show();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_5"):Show();
			getglobal("acsConfPanelFrameSpellsEdit"..( 21-i ).."_7"):Show();
			getglobal("acsConfPanelFrameSpellsCheckButton"..( 21-i ).."_6"):Show();
		end
	end

	for i=1,19 do
		if ( ( acsConfPanelFrameHealsSlider:GetValue() )<=( 20-i ) ) then
			getglobal("acsConfPanelFrameHealsCheckButton"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameHealsEdit"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameHealsEdit"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameHealsEdit"..( 21-i ).."_3"):Hide();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_3"):Hide();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_4"):Hide();
			getglobal("acsConfPanelFrameHealsCheckButton"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_5"):Hide();
		else
			getglobal("acsConfPanelFrameHealsCheckButton"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameHealsEdit"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameHealsEdit"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameHealsEdit"..( 21-i ).."_3"):Show();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_3"):Show();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_4"):Show();
			getglobal("acsConfPanelFrameHealsCheckButton"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameHealsLabel"..( 21-i ).."_5"):Show();
		end
	end

	for i=1,19 do
		if ( ( acsConfPanelFrameBuffsSlider:GetValue() )<=( 20-i ) ) then
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameBuffsEdit"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameBuffsEdit"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_3"):Hide();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_1"):Hide();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_2"):Hide();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_3"):Hide();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_4"):Hide();
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_4"):Hide();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_5"):Hide();
		else
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameBuffsEdit"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameBuffsEdit"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_3"):Show();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_1"):Show();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_2"):Show();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_3"):Show();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_4"):Show();
			getglobal("acsConfPanelFrameBuffsCheckButton"..( 21-i ).."_4"):Show();
			getglobal("acsConfPanelFrameBuffsLabel"..( 21-i ).."_5"):Show();
		end
	end

end

function acsCleanUpVars()

	for iP = 1,3 do
	
		for i = (-20),(-1) do
			if ( tonumber( acs[acsPlayerName][acsClass]["SkillSlot"][iP][-i] ) == 0 ) then
				acs[acsPlayerName][acsClass]["SkillSlot"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillEnabled"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillCheck1"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillExist1"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillCheck2"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillExist2"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillHP"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillPercentHP"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillMP"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillPercentMP"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillName"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["SkillStopMove"][iP][-i] = nil;
			else
				break;
			end
		end

		for i = (-20),(-1) do
			if ( tonumber( acs[acsPlayerName][acsClass]["BuffSlot"][iP][-i] ) == 0 ) then
				acs[acsPlayerName][acsClass]["BuffSlot"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["BuffEnabled"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["BuffName"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["BuffCombat"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["BuffCombatOnly"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["BuffOthers"][iP][-i] = nil;
			else
				break;
			end
		end

		for i= (-20),(-1) do
			if ( tonumber( acs[acsPlayerName][acsClass]["HealSlot"][iP][-i] ) == 0 ) then
				acs[acsPlayerName][acsClass]["HealSlot"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealEnabled"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealBuff"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealPercent"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealOthers"][iP][-i] = nil;
			else
				break;
			end
		end

		for i= (-20),(-1) do
			if ( tonumber( acs[acsPlayerName][acsClass]["HealthPotionSlot"][iP][-i] ) == 0 ) then
				acs[acsPlayerName][acsClass]["HealthPotionSlot"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealthPotionEnabled"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealthPotionBuff"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealthPotionPercent"][iP][-i] = nil;
				acs[acsPlayerName][acsClass]["HealthPotionOutEnabled"][iP][-i] = nil;
			else
				break;
			end
		end
		
	end

end

function acsCopyProfile(copywhat,intowhat)

	for i = 1,20 do
		acs[acsPlayerName][acsClass]["SkillSlot"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillSlot"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillEnabled"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillEnabled"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillCheck1"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillCheck1"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillExist1"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillExist1"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillCheck2"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillCheck2"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillExist2"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillExist2"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillHP"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillHP"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillPercentHP"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillPercentHP"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillMP"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillMP"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillPercentMP"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillPercentMP"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillName"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillName"][copywhat][i];
		acs[acsPlayerName][acsClass]["SkillStopMove"][intowhat][i] = acs[acsPlayerName][acsClass]["SkillStopMove"][copywhat][i];
	end
	
end
